/**
 * \file
 *
 * \brief USBulԲ̪u(HID)ϳ ̪
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDI_HID_MOUSE_H_
#define _UDI_HID_MOUSE_H_

#include "conf_usb.h"
#include "usb_protocol.h"
#include "usb_protocol_hid.h"
#include "udc_desc.h"
#include "udi.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup udi_hid_mouse_group_udc
 * @{
 */
//! UDCpWUDI API܂ޑS̍\
extern UDC_DESC_STORAGE udi_api_t udi_api_hid_mouse;
//@}

/**
 * \ingroup udi_hid_mouse_group
 * \defgroup udi_hid_mouse_group_desc USB̪-Lqq
 *
 * ȉ̍\̂͗\ߒ`ꂽUSB̪Lqq񋟂܂B
 * ͍ŏIIUSBLqq`̂ɎgpȂ΂Ȃ܂B
 */
//@{

//! HIDϳp̪Lqq\
typedef struct {
	usb_iface_desc_t iface;
	usb_hid_descriptor_t hid;
	usb_ep_desc_t ep;
} udi_hid_mouse_desc_t;

//! HIDϳp񍐋Lqq
typedef struct {
	uint8_t array[25 * 2 + 2 * 1];
} udi_hid_mouse_report_desc_t;


//! ł̲̪Ɋ֘AȂ
#ifndef UDI_HID_MOUSE_STRING_ID
#define UDI_HID_MOUSE_STRING_ID		0
#endif

//! HIDϳ ߲Ă̑傫
#define UDI_HID_MOUSE_EP_SIZE		8

//! SĂ̑xɑ΂HIDϳ ̪̓e
#define UDI_HID_MOUSE_DESC    {\
	.iface.bLength				= sizeof(usb_iface_desc_t),\
	.iface.bDescriptorType		= USB_DT_INTERFACE,\
	.iface.bInterfaceNumber		= UDI_HID_MOUSE_IFACE_NUMBER,\
	.iface.bAlternateSetting	= 0,\
	.iface.bNumEndpoints		= 1,\
	.iface.bInterfaceClass		= HID_CLASS,\
	.iface.bInterfaceSubClass	= HID_SUB_CLASS_BOOT,\
	.iface.bInterfaceProtocol	= HID_PROTOCOL_MOUSE,\
	.iface.iInterface			= UDI_HID_MOUSE_STRING_ID,\
	.hid.bLength				= sizeof(usb_hid_descriptor_t),\
	.hid.bDescriptorType		= USB_DT_HID,\
	.hid.bcdHID					= LE16(USB_HID_BDC_V1_11),\
	.hid.bCountryCode			= USB_HID_NO_COUNTRY_CODE,\
	.hid.bNumDescriptors		= USB_HID_NUM_DESC,\
	.hid.bRDescriptorType		= USB_DT_HID_REPORT,\
	.hid.wDescriptorLength		= LE16(sizeof(udi_hid_mouse_report_desc_t)),\
	.ep.bLength					= sizeof(usb_ep_desc_t),\
	.ep.bDescriptorType			= USB_DT_ENDPOINT,\
	.ep.bEndpointAddress		= UDI_HID_MOUSE_EP_IN,\
	.ep.bmAttributes			= USB_EP_TYPE_INTERRUPT,\
	.ep.wMaxPacketSize			= LE16(UDI_HID_MOUSE_EP_SIZE),\
	.ep.bInterval				= 10,\
	}
//@}
//@}


/**
 * \ingroup udi_hid_group
 * \defgroup udi_hid_mouse_group lԲ̪u(HID)ϳ ׽pUSBu̪(UDI)
 *
 * USB׽gp邽߂ɍʉpɂĎgp鋤API
 *
 * \ref udi_hid_mouse_quickstartB
 * @{
 */

/**
 * \name ϳۗp̪
 */
//@{

/**
 * \brief ۰ٗֈړ
 *
 * \param	pos		ړ镄l
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_moveScroll(int8_t pos);

/**
 * \brief Yϳ ߲ړ
 *
 * \param	pos_y	ړ镄l
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_moveY(int8_t pos_y);

/**
 * \brief Xϳ ߲ړ
 *
 * \param	pos_x   ړ镄l
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_moveX(int8_t pos_x);
//@}

/**
 * \name tۗp̪-
 */
//@{

#define  HID_MOUSE_BTN_DOWN		true	//!< t()}邽߂̒l
#define  HID_MOUSE_BTN_UP		false	//!< t(J)}邽߂̒l

/**
 * \brief tԕω
 *
 * \param	b_state		Vt̏
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_btnmiddle(bool b_state);

/**
 * \brief Etԕω
 *
 * \param	b_state		Vt̏
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_btnright(bool b_state);

/**
 * \brief tԕω
 *
 * \param	b_state		Vt̏
 *
 * \return	֐I\c 1AȂ\c 0
 */
bool udi_hid_mouse_btnleft(bool b_state);
//@}

//@}

#ifdef __cplusplus
}
#endif

/**
 * \page udi_hid_mouse_quickstart USBuϳJ(UDIϳ)pJn̎
 *
 * ͑IƎgpʂł̒Pʕ`Ԑݒ肵Ďg@̒iKIȎwł
 * \ref udi_hid_mouse_group "USBuϳPʕ(UDIϽ)"pJn̎łB
 *
 * gpʂ͂̺ĒfЂ܂݂܂BpiKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAŎgpiK͗Ⴆ΁A剞p֐ɕʂ邱
 * ł܂B
 * 
 * ܂Aȉ̉pLqQƂ邱Ƃł܂B
 * <A href="http://www.atmel.com/dyn/resources/prod_documents/doc8409.pdf">
 * AVR4903: ASF - USBuHIDϳp</A>.
 *
 * \section udi_hid_mouse_basic_use_case {IȎgp
 * ̊{IȎgpʂł"USB HIDϳ(P̪u)"Pʕgp܂B
 * "USB HIDϳ(u)"Pʕ̎g\ref udi_hid_mouse_use_cases "xȎg
 * p"ŋLq܂B
 *
 * \section udi_hid_mouse_basic_use_case_setup iK
 * \subsection udi_hid_mouse_basic_use_case_setup_prereq OKv
 * \copydetails udc_basic_use_case_setup_prereq
 * \subsection udi_hid_mouse_basic_use_case_setup_code ޗ
 * \copydetails udc_basic_use_case_setup_code
 * \subsection udi_hid_mouse_basic_use_case_setup_flow Ƃ̗
 * \copydetails udc_basic_use_case_setup_flow
 *
 * \section udi_hid_mouse_basic_use_case_usage giK
 *
 * \subsection udi_hid_mouse_basic_use_case_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define UDI_HID_MOUSE_ENABLE_EXT() my_callback_mouse_enable()
 * extern bool my_callback_mouse_enable(void);
 * #define UDI_HIDMOUSE_DISABLE_EXT() my_callback_mouse_disable()
 * extern void my_callback_mouse_disable(void);
 * #include "udi_hid_mouse_conf.h"	// conf_usb.ḩق̍Ō
 * \endcode
 *
 * pÇقɒǉ:
 * \code
 * static bool my_flag_autorize_mouse_events = false;
 * bool my_callback_mouse_enable(void)
 * {
 *    my_flag_autorize_mouse_events = true;
 *    return true;
 * }
 * void my_callback_mouse_disable(void)
 * {
 *    my_flag_autorize_mouse_events = false;
 * }
 *
 * void my_button_press_event(void)
 * {
 *    if (!my_flag_autorize_mouse_events) {
 *       return;
 *    }
 *    udi_hid_mouse_btnleft(HID_MOUSE_BTN_DOWN);
 * }
 * \endcode
 *
 * \subsection udi_hid_mouse_basic_use_case_setup_flow Ƃ̗
 * -# conf_usb.hp\USBuϳ`Ԑݒłȉ̌`Ԑݒ܂ނƂ
 * mɂĂB:
 *   - \code #define UDI_HID_MOUSE_ENABLE_EXT() my_callback_mouse_enable()
 * extern bool my_callback_mouse_enable(void); \endcode
 *     \note u(USBǔoƎ)AUSBνĂ͑u`Ԑݒn߂܂B
 *     νĂɂđuUSBϳ ̪󂯓ƁAUSBνĂ̲͂
 *     ̪UDI_HIDMOUSE_ENABLE_EXT()Ăі߂֐Ă΂Đ^(true)
 *     Ԃ܂B̂ɁÅ֐ϳɂĎgp銴m邱Ƃ
 *     ܂B
 *   - \code #define UDI_HIDMOUSE_DISABLE_EXT() my_callback_mouse_disable()
 * extern void my_callback_mouse_disable(void); \endcode
 *     \note USBuؒf邩A܂USB1νĂɂؾĂƁAUSB
 *     ̪͋֎~AUDI_HIDMOUSE_DISABLE_EXT()Ăі߂֐Ă΂܂B̂
 *     ̊֐ϳɂĎgp銴m킪֎~邱Ƃ܂B
 * -# ϳۑo
 *   - \code	// ۰ٗւł̒l𑗏o
 * udi_hid_mouse_moveScroll(int8_t pos);
 * // ϳ ߲łYl𑗏o
 * udi_hid_mouse_moveY(int8_t pos_y);
 * // ϳ ߲łXl𑗏o
 * udi_hid_mouse_moveX(int8_t pos_x);
 * // دۂ𑗏o
 * udi_hid_mouse_btnmiddle(bool b_state);
 * // Eدۂ𑗏o
 * udi_hid_mouse_btnright(bool b_state);
 * // دۂ𑗏o
 * udi_hid_mouse_btnleft(bool b_state); \endcode
 *
 * \section udi_hid_mouse_use_cases xȎgp
 * UDI HIDϳPʕ̂ƍxȎgpɂĂ͈ȉ̎gpʂB:
 * - \subpage udi_hid_mouse_use_case_composite
 * - \subpage udc_use_case_1
 * - \subpage udc_use_case_2
 * - \subpage udc_use_case_3
 * - \subpage udc_use_case_4
 * - \subpage udc_use_case_5
 * - \subpage udc_use_case_6
 */

/**
 * \page udi_hid_mouse_use_case_composite ułHIDϳ
 *
 * USBu͕USB׽gUSBułB̎gpʂłUSBu
 * ̂"USB HIDϳ(u)"Pʕgp܂B̂ɂUSBPʕ
 * "USB MSC(u)"̂悤ȕʂ"u"PʕƘAg꓾܂B
 * 
 * ܂Aȉ̉pLqQƂ邱Ƃł܂B
 * <A href="http://www.atmel.com/dyn/resources/prod_documents/doc8445.pdf">
 * AVR4902 ASF - USBu</A>.
 *
 * \section udi_hid_mouse_use_case_composite_setup iK
 * ߂̂̎gpʂ̏ނɂĂ
 * \ref udi_hid_mouse_basic_use_case"{IȎgp"ɏ]Ȃ΂Ȃ܂B
 *
 * \section udi_hid_mouse_use_case_composite_usage giK
 *
 * \subsection udi_hid_mouse_use_case_composite_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define USB_DEVICE_EP_CTRL_SIZE  64
 * #define USB_DEVICE_NB_INTERFACE (X+1)
 * #define USB_DEVICE_MAX_EP (X+1)
 *
 * #define UDI_HID_MOUSE_EP_IN  (X | USB_EP_DIR_IN)
 * #define UDI_HID_MOUSE_IFACE_NUMBER  X
 *
 * #define UDI_COMPOSITE_DESC_T \
 *    udi_hid_mouse_desc_t udi_hid_mouse; \
 *    ...
 * #define UDI_COMPOSITE_DESC_FS \
 *    .udi_hid_mouse = UDI_HID_MOUSE_DESC, \
 *    ...
 * #define UDI_COMPOSITE_DESC_HS \
 *    .udi_hid_mouse = UDI_HID_MOUSE_DESC, \
 *    ...
 * #define UDI_COMPOSITE_API \
 *    &udi_api_hid_mouse, \
 *    ...
 * \endcode
 *
 * \subsection udi_hid_mouse_use_case_composite_usage_flow Ƃ̗
 * -# conf_usb.hp\USBu`Ԑݒɑ΂ĕKvƂȉҰ
 * ܂ނƂmɂĂB
 *   - \code	// ߲Đ̑傫B͈ȉłȂ΂Ȃ܂B:
 * // - ᑬɑ΂8
 * // - Suɑ΂8,16,32,܂64(RAMߖ̂8𐄏)
 * // - uɑ΂64
 * #define USB_DEVICE_EP_CTRL_SIZE  64
 * // USBuł̪̑
 * // HIDϳp1ǉ
 * #define USB_DEVICE_NB_INTERFACE (X+1)
 * // USBuł߲̑Đ
 * // ͊e̪ɑ΂e߲Ă܂܂Ȃ΂Ȃ܂B
 * // HIDϳp1ǉ
 * #define USB_DEVICE_MAX_EP (X+1) \endcode
 * -# conf_usb.hűLq܂ނƂmɂĂB:
 *   - \code	// ϳpɂȂɂđI΂ꂽ߲Ĕԍ
 * // ߲Ĕԍ1n܂܂B
 * #define UDI_HID_MOUSE_EP_IN  (X | USB_EP_DIR_IN)
 * // ̪̲̪wW0n܂܂B
 * #define UDI_HID_MOUSE_IFACE_NUMBER  X \endcode
 * -# conf_usb.hUSBu`Ԑݒɑ΂ĕKvƂȉҰ܂ނ
 * mɂĂB:
 *   - \code	// USB̪Lqq\
 * #define UDI_COMPOSITE_DESC_T \
 *    ...
 *    udi_hid_mouse_desc_t udi_hid_mouse; \
 *    ...
 * // SpUSB̪Lqql
 * #define UDI_COMPOSITE_DESC_FS \
 *    ...
 *    .udi_hid_mouse = UDI_HID_MOUSE_DESC, \
 *    ...
 * // pUSB̪Lqql
 * #define UDI_COMPOSITE_DESC_HS \
 *    ...
 *    .udi_hid_mouse = UDI_HID_MOUSE_DESC, \
 *    ...
 * // USB̪API
 * #define UDI_COMPOSITE_API \
 *    ...
 *    &udi_api_hid_mouse, \
 *    ... \endcode
 *   - \note 4̈ꗗŗ^ꂽLqq̏Ԃ͑SĂ̲̪wWɂ
 *     `鏇ԂƓłȂ΂Ȃ܂B̪wW
 *     UDI_X_IFACE_NUMBER`ʂĒ`܂B
 */

#endif // _UDI_HID_MOUSE_H_
