/**
 * \file
 *
 * \brief AVR XMEGA A/Dϊײ
 *
 * 쌠 (C) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include <compiler.h>
#include <adc.h>

/**
 * \ingroup adc_module_group
 * @{
 */

/** \name ADC荞݌Ăі߂֐ */
/** @{ */
#ifdef ADCA

/**
 * \internal
 * \brief ADC Av
 *
 * ͂̒Pʕ܂ق̌`Ԑݒ肪XVꂽADC Asӂɋ֎~
 * ȂƂۏ؂邽߂Ɏgp܂B
 */
static uint8_t adca_enable_count;

#  ifdef CONFIG_ADC_CALLBACK_ENABLE

/**
 * \internal
 * \brief ADC A荞݌Ăі߂֐ʒuwq
 */
adc_callback_t adca_callback;

#  endif
#endif

#ifdef ADCB

/**
 * \internal
 * \brief ADC Bv
 *
 * ͂̒Pʕ܂ق̌`Ԑݒ肪XVꂽADC Bsӂɋ֎~
 * ȂƂۏ؂邽߂Ɏgp܂B
 */
static uint8_t adcb_enable_count;

#  ifdef CONFIG_ADC_CALLBACK_ENABLE

/**
 * \internal
 * \brief ADC B荞݌Ăі߂֐ʒuwq
 */
adc_callback_t adcb_callback;

#  endif
#endif

#if defined(CONFIG_ADC_CALLBACK_ENABLE) || defined(__DOXYGEN__)

/**
 * \brief ADC荞݌Ăі߂֐ݒ
 *
 * w肵ADCł̊荞݂ɑ΂VĂі߂֐ݒ肵܂B
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	callback	ݒ肷Ăі߂֐ւ̈ʒuwq
 */
void adc_set_callback(ADC_t *adc, adc_callback_t callback)
{
	irqflags_t flags;

	Assert(callback);

	flags = cpu_irq_save();

#ifdef ADCA
	if ((uintptr_t)adc == (uintptr_t)&ADCA) {
		adca_callback = callback;
	} else
#endif

#ifdef ADCB
	if ((uintptr_t)adc == (uintptr_t)&ADCB) {
		adcb_callback = callback;
	} else
#endif

	{
		Assert(0);
	}

	cpu_irq_restore(flags);
}

#endif /* CONFIG_ADC_CALLBACK_ENABLE */

/** @} */

/** \name ײޗp֐ */
/** @{ */

/**
 * \internal
 * \brief ADCpӋ@\ۯ
 *
 * ADCp̋v킪0𒲂ׂāA𑝂₵܂Bv0ȂAӋ@
 * \ۯ܂BȂ΁A͊ɋĂ܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 */
void adc_enable_clock(ADC_t *adc);

void adc_enable_clock(ADC_t *adc)
{
#ifdef ADCA
	if ((uintptr_t)adc == (uintptr_t)(&ADCA)) {
		Assert(adca_enable_count < 0xff);
		if (!adca_enable_count++) {
			sysclk_enable_module(SYSCLK_PORT_A, SYSCLK_ADC);
		}
	} else
#endif

#ifdef ADCB
	if ((uintptr_t)adc == (uintptr_t)(&ADCB)) {
		Assert(adcb_enable_count < 0xff);
		if (!adcb_enable_count++) {
			sysclk_enable_module(SYSCLK_PORT_B, SYSCLK_ADC);
		}
	} else
#endif

	{
		Assert(0);
	}
}

/**
 * \internal
 * \brief ADCpӋ@\ۯ֎~
 *
 * ADCpv炵Av0ɓȂA̎Ӌ@\ۯ֎~
 * Bv0ɓȂꍇAADCĂ邱Ƃ܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 */
void adc_disable_clock(ADC_t *adc);

void adc_disable_clock(ADC_t *adc)
{
#ifdef ADCA
	if ((uintptr_t)adc == (uintptr_t)(&ADCA)) {
		Assert(adca_enable_count);
		if (!--adca_enable_count) {
			sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_ADC);
		}
	} else
#endif

#ifdef ADCB
	if ((uintptr_t)adc == (uintptr_t)(&ADCB)) {
		Assert(adcb_enable_count);
		if (!--adcb_enable_count) {
			sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_ADC);
		}
	} else
#endif

	{
		Assert(0);
	}
}

/** @} */

/** \name ADCPʕǗ */
/** @{ */

/**
 * \brief ADC
 *
 * ADCċx~Ǘɑ΂IDLEɌŒ肵܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 *
 * \note mȕϊۏ؂邽߁AADCPʕ̋ƕϊ̊ԂōŒAw肵n
 * Ԃ҂ĂBwǂXMEGA޲ɑ΂ĎnԂ͍ő24 ADCۯ
 * Ɏw肳܂Bgp޲ɑ΂nԂmFĂB
 */
void adc_enable(ADC_t *adc)
{
	irqflags_t flags = cpu_irq_save();
	adc_enable_clock(adc);
	adc->CTRLA |= ADC_ENABLE_bm;
	cpu_irq_restore(flags);

	sleepmgr_lock_mode(SLEEPMGR_IDLE);
}

/**
 * \brief ADC֎~
 *
 * ADC֎~ċx~Ǘɑ΂IDLE܂B
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 */
void adc_disable(ADC_t *adc)
{
	irqflags_t flags = cpu_irq_save();
	adc->CTRLA &= ~ADC_ENABLE_bm;
	adc_disable_clock(adc);
	cpu_irq_restore(flags);

	sleepmgr_unlock_mode(SLEEPMGR_IDLE);
}

/**
 * \brief ADCĂ邩
 *
 * \param	adc		ADCPʕւ̈ʒuwq
 *
 * \retval	true	ADCĂꍇ
 * \retval	false	ADC֎~Ăꍇ
 */
bool adc_is_enabled(ADC_t *adc)
{
	/* vύXSĂײފ֐荞݂ɑ΂ĕی삳A/֎~̊
	 * ߂ő/vŋ邽߁AADCv̏ԂԂ
	 * ŏ[łB
	 */
#ifdef ADCA
	if ((uintptr_t)adc == (uintptr_t)&ADCA) {
		return adca_enable_count;
	} else
#endif

#ifdef ADCB
	if ((uintptr_t)adc == (uintptr_t)&ADCB) {
		return adcb_enable_count;
	} else
#endif

	{
		Assert(0);
		return false;
	}
}

/** @} */

/** @} */
