/**
 * \file
 *
 * \brief ݒ\ȑi荞ݐײ
 *
 * 쌠 (C) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef PMIC_H
#define PMIC_H

#include <compiler.h>
#include <ccp.h>

/**
 * \defgroup pmic_group ݒ\ȑi荞ݐ
 *
 * \ref xmega_pmic_quickstartB
 *
 * AVR XMEGAݒ\ȑi荞ݐpײގłB
 *
 * \note ̊֐荞ݏٰ(ISR)ŎgpꍇAႢق̊
 * 荞݂ɑ΂ǂ̔ISRނISRނ񕪒fAA֐Ăяo̊荞
 * ֎~ɂ邱Ƃۏ؂Ȃ΂Ȃ܂B
 * @{
 */

/**
 * \brief 荞 ޯĎՕ
 *
 * \note ́AႦΕق܂͋֎~ꍇOR邩
 * ܂B
 */
enum pmic_level {
	PMIC_LVL_LOW    = PMIC_LOLVLEN_bm,		//!< ي荞
	PMIC_LVL_MEDIUM = PMIC_MEDLVLEN_bm,		//!< ي荞
	PMIC_LVL_HIGH   = PMIC_HILVLEN_bm,		//!< ي荞
	/**
	 * \brief Օs荞
	 * \note ͋֎~ł܂B
	 */
	PMIC_LVL_NMI    = PMIC_NMIEX_bp,
};

//! 荞޸ʒu
enum pmic_vector {
	PMIC_VEC_APPLICATION,	//!< p̈
	PMIC_VEC_BOOT,			//!< ްė̈
	PMIC_NR_OF_VECTORS,		//!< 荞޸ʒu
};

//! 荞݌v̎dg
enum pmic_schedule {
	PMIC_SCH_FIXED_PRIORITY,	//!< AŒD揇v
	PMIC_SCH_ROUND_ROBIN,		//!< ׳ ݌v
	PMIC_NR_OF_SCHEDULES,		//!< 荞݌v̎dgݐ
};

/**
 * \brief PMIC
 *
 * p̈ɒuꂽ޸ƌŒD揇vőS荞ق
 */
static inline void pmic_init(void)
{
	PMIC.CTRL = PMIC_LVL_LOW | PMIC_LVL_MEDIUM |
			PMIC_LVL_HIGH;
}

/**
 * \brief w肵\a levelł̊荞݂
 *
 * \param	level	銄荞
 */
static inline void pmic_enable_level(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	PMIC.CTRL |= level;
}

/**
 * \brief w肵\a levelł̊荞݂֎~
 *
 * \param	level	֎~銄荞
 */
static inline void pmic_disable_level(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	PMIC.CTRL &= ~level;
}

/**
 * \brief w肵荞\a level
 *
 * \param	level	ׂ銄荞
 *
 * \return 荞قĂTrue
 */
static inline bool pmic_level_is_enabled(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	return PMIC.CTRL & level;
}

/**
 * \brief ݋ꂽق擾
 *
 * \return ݋ĂقޯĎՕ
 */
static inline enum pmic_level pmic_get_enabled_levels(void)
{
	return (enum pmic_level)(PMIC.CTRL & (PMIC_LVL_LOW | PMIC_LVL_MEDIUM
				| PMIC_LVL_HIGH));
}

/**
 * \brief 荞قݎs
 *
 * \param	level	ׂ銄荞
 *
 * \return 荞قݎsȂTrue
 */
static inline bool pmic_level_is_executing(enum pmic_level level)
{
	return PMIC.STATUS & level;
}

/**
 * \brief ʊ荞݂ɑ΂Ċ荞݌vݒ
 *
 * \param	schedule	ݒ肷銄荞݌v@
 *
 * \note D挠޸INTPRI׳ ݌v悪֎~ꂽɊ芄荞ݗD揇
 * Ԃ߂0ɐݒ肳Ȃ΂Ȃ܂B
 */
static inline void pmic_set_scheduling(enum pmic_schedule schedule)
{
	Assert(schedule < PMIC_NR_OF_SCHEDULES);

	switch (schedule) {
	case PMIC_SCH_FIXED_PRIORITY:
		PMIC.CTRL &= ~PMIC_RREN_bm;
		PMIC.INTPRI = 0;
		break;

	case PMIC_SCH_ROUND_ROBIN:
		PMIC.CTRL |= PMIC_RREN_bm;
		break;

	default:
		break;
	};
}

/**
 * \brief 荞޸̈ʒuݒ
 *
 * \param	vector	荞޸Ɏgpʒu
 */
static inline void pmic_set_vector_location(enum pmic_vector vector)
{
	uint8_t ctrl = PMIC.CTRL;

	Assert(vector < PMIC_NR_OF_VECTORS);

	switch (vector) {
	case PMIC_VEC_APPLICATION:
		ctrl &= ~PMIC_IVSEL_bm;
		break;

	case PMIC_VEC_BOOT:
		ctrl |= PMIC_IVSEL_bm;
		break;

	default:
		break;
	}

	ccp_write_io((uint8_t*)&PMIC.CTRL, ctrl);
}

//! @}

/**
 * \page xmega_pmic_quickstart PMICײޗpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďg@̒iKIȎwł
 * \ref pmic_group "PMICײ"ƖڂɊ֘A\ref interrupt_group "S̊荞
 * ײޗp̑Jn̎łB
 *
 * gpʂ͂̺ޒfЂ܂݂܂BpiKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAŎgpiK͗Ⴆ΁A剞p֐ɕʂ邱
 * ł܂B
 *
 * \section pmic_basic_use_case {IȎgp
 * ̊{IȎgpʂłPMIC̗lɌ`Ԑݒ肳܂B:
 * - S荞ً
 * - ׳ ݌v
 *
 * ͎gp鑼̒Pʕ̊荞݂܂B
 *
 * \section pmic_basic_use_case_setup iK
 *
 * \subsection pmic_basic_use_case_setup_prereq OKv
 * ߂̂̎gpʂ̏-ނɑ΂āAۼުĂɈȉǉȂ
 * Ȃ܂B:
 * -# PMICPʕKvƂPʕp荞݂͋Ȃ΂Ȃ܂B
 * -# ^ꂽ荞޸ɑ΂銄荞ݏٰ(ISR)ްĂ'荞޸
 *    v'ňꗗɂ°݂ɂĒ`闘p\Ȋ荞޸Œ
 *    `Ȃ΂Ȃ܂B
 * \code
 *     ISR(interrupt_vector){
 *         // 荞ݏٰ
 *     }
 * \endcode
 *
 * \subsection pmic_basic_use_case_setup_code ޗ
 * ނɒǉ܂B:
 * \code
 *     pmic_init();
 *     pmic_set_scheduling(PMIC_SCH_ROUND_ROBIN);
 *     cpu_irq_enable();
 * \endcode
 *
 * \subsection pmic_basic_use_case_setup_flow Ƃ̗
 * -# SĂ̊荞ق邽߂PMICײގg̏֐Ăт܂B:
 *   - \code pmic_init(); \endcode
 * -# ŒD挠荞݌v̑׳ ݂܂B:
 *   - \code pmic_set_scheduling(PMIC_SCH_ROUND_ROBIN); \endcode
 * -# 荞݂S̓Iɋ܂B:
 *   - \code cpu_irq_enable(); \endcode
 *   - \attention 荞݂͂̒iKȂŋN܂B
 *
 * \section pmic_use_cases xȎgp
 * PMICײނ̂ƍxȎgpɂĂ͈ȉ̎gpʂB:
 * - \subpage pmic_use_case_1 : 񕪒f
 */

/**
 * \page pmic_use_case_1 gp#1
 *
 * ̎gpʂłPMIC̗lɌ`Ԑݒ肳܂B:
 * - ̊荞ق
 * 
 * ͎gp鑼̒Pʕ̊荞݂܂B
 *
 * ̎gpʂ͊荞ݕs\ȕ߂琬鑀AA񕪒f@
 * ܂B͊荞ݏɂް꓾āAɑ̺ނ
 * 𱸾Ă̍Œ1ύX댯ꍇɓxXKvłB
 *
 * \section pmic_use_case_1_setup iK
 *
 * \subsection pmic_basic_use_case_setup_prereq OKv
 * ߂̂̎gpʂ̏ނ̂߂ɁAۼުĂɈȉǉȂ
 * Ȃ܂B:
 * -# PMICPʕKvƂPʕp荞݂Ȃ΂Ȃ܂B
 * -# ^ꂽ荞޸ɑ΂銄荞ݏٰ(ISR)ްĂ'荞޸
 *    v'ňꗗɂ°݂ɂĒ`闘p\Ȋ荞޸Œ
 *    `Ȃ΂Ȃ܂B
 * \code
 *     ISR(interrupt_vector){
 *         // 荞ݏٰ
 *     }
 * \endcode
 *
 * \subsection pmic_use_case_1_setup_code ޗ
 * pɒǉ܂B:
 * \code
 *     pmic_init();
 *     cpu_irq_enable();
 * \endcode
 *
 * \subsection pmic_use_case_1_setup_flow Ƃ̗
 * -# SĂ̊荞ق邽߂PMICײގg̏֐Ăт܂B:
 *   - \code pmic_init(); \endcode
 * -# S̊荞݋׸ނݒ肵܂B:
 *   - \code cpu_irq_enable(); \endcode
 *
 * \section pmic_use_case_1_usage giK
 *
 * \subsection pmic_use_case_1_usage_code ޗ
 * \code
 * pɒǉ܂B:
 * void atomic_operation(void)
 * {
 *     irqflags_t flags;
 *
 *     flags = cpu_irq_save();
 *
 *     // ނ̊荞ݕs̉
 *
 *     cpu_irq_restore(flags);
 * }
 * \endcode
 *
 * \subsection pmic_use_case_1_usage_flow Ƃ̗
 * -# 荞݋ɑ΂ĈꎞL蓖Ă܂B:
 *   - \code irqflags_t flags; \endcode
 * -# S̊荞݋׸ނ̈ȑȌԂۑƓɂ܂B:
 *   - \code flags = cpu_irq_save(); \endcode
 * -# ɑS̊荞׸ނ̈ȑȌԂɕ܂B:
 *   - \code cpu_irq_restore(flags); \endcode
 */

#endif /* PMIC_H */
