/**
 * \file
 *
 * \brief x~ײ
 *
 * 쌠 (c) 2010 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SLEEP_H
#define SLEEP_H

#include <compiler.h>

/**
 * \defgroup sleep_group x~ײ
 *
 * AVR XMEGAx~pײގłB
 *
 * \note ނ̊Ԑڕׂŏɂ邽߁AA炪荞ݏ̓܂
 * ͂̂悤ȕی삪svȏꏊŌĂ΂̂ŁÅ֐͊荞ݕی삳ꂽ
 * Ƃ܂B̂悤ȕی삪KvƂȂAނĂԂƂ
 * ĕۏ؂Ȃ΂Ȃ܂B
 *
 * \section xmega_sleep_quickstart_section Jn̎
 * \ref xmega_sleep_quickstartB
 * @{
 */

#if defined(__ICCAVR__) || defined(__DOXYGEN__)
# include <intrinsics.h>
//! x~߂𔭍s邽߂ϸ
# define sleep_enter() __sleep()

/**
 * \brief x~
 */
static inline void sleep_enable(void)
{
	SLEEP.CTRL |= SLEEP_SEN_bm;
}

/**
 * \brief x~֎~
 */
static inline void sleep_disable(void)
{
	SLEEP.CTRL &= ~SLEEP_SEN_bm;
}

#elif defined(__GNUC__)
# include <avr/sleep.h>
# define sleep_enter() sleep_cpu()

#else
# error Unsupported compiler.
#endif

/**
 * \brief Vx~ݒ
 *
 * \param	mode	޲I/Oͯ ̧ق̋x~
 */
static inline void sleep_set_mode(enum SLEEP_SMODE_enum mode)
{
	SLEEP.CTRL = mode | (SLEEP.CTRL & ~SLEEP_SMODE_gm);
}

//! @}

/**
 * \page xmega_sleep_quickstart XMEGAx~ײޗpJn̎
 *
 * ͎wgpʂɑ΂Č`ԐݒƎgp̕@̒iKIwł
 * \ref sleep_group "x~ײ"pJn̎łB
 *
 * ŋLq鍀͗Ⴆ΁A޲ňႤx~𐧌䂵Ďs邱ƂKv
 * 剞pJԂ⑼̊֐ɕʂ邱Ƃł܂B
 *
 * \section xmega_sleep_quickstart_basic x~ײނ̊{IȎg
 * ̎gpʂܰ޳݋x~ֈڍs悤޲Ă̌ɂ̋x
 * ~ֈڍs܂BNオɋx~֎~܂B
 *
 * \section xmega_sleep_basic_usage giK
 * \subsection xmega_sleep_basic_usage_code ޗ
 * Ⴆ΁ApÇقŎJԂɒǉ܂B:
 * \code
 * sleep_set_mode(SLEEP_SMODE_PDOWN_gc);
 * sleep_enable();
 * sleep_enter();
 * sleep_disable();
 * \endcode
 *
 * \subsection xmega_sleep_basic_usage Ƃ̗
 * -# gpx~ݒAႤx~޲ ͯ ̧قSLEEP_SMODE_enum
 *  񋓒`Ō邱Ƃł܂B:
 *  - \code sleep_set_mode(SLEEP_SMODE_PDOWN_gc); \endcode
 * -# ޲x~֍ŝ邱Ƃ܂B:
 *  - \code sleep_enable(); \endcode
 *  - \note ̊֐޲x~֍s߂ɌĂ΂Ȃ΂Ȃ܂B
 *  Ⴆɂ̋\ĂA\x~֍s޲~߂邽
 *  ߂̊S@\łBۯŋx~֍sƂӐ}鎞ɂx~
 *  邱Ƃ܂B
 * -# x~ֈڍs܂B:
 *  - \code sleep_enter(); \endcode
 *  - \attention ޲ɑ΂ċNオ茳ƂĎgpv抄荞݂ƑS̊
 *  ݂邱ƂmAex~ɑ΂Ăǂ̋Nオ茳p\
 *  ɂʂȒӂ𕥂ĂB荞݋ɑ΂鎸s͓d͂OFF/ON
 *  ܂Ŗ̋x~ɋA邩܂B!
 * -# ޲x~NƁANオ茳(荞݌)Ɋ֘A銄荞ݏ
 *  sA\ref sleep_enter()Ăяo̺̎ލs𑱂܂BNオ
 *  ɋx~̋֎~mɂĂB
 *  - \code sleep_disable(); \endcode
 *
 *  \subsection xmega_sleep_basic_sleep_modes x~
 *  \ȋx~͎gp޲Ɉˑ܂B̒`ɑ΂Ă޲
 *  ްĂͯ ̧قQƂĂB
 *
 *  ƂATxmega32A4U޲͈ȉ̋x~܂B:
 *  - ًx~: SLEEP_SMODE_IDLE_gc
 *  - ܰ޳: SLEEP_SMODE_PDOWN_gc
 *  - ܰ: SLEEP_SMODE_PSAVE_gc
 *  - ޲: SLEEP_SMODE_STDBY_gc
 *  - g޲: SLEEP_SMODE_ESTDBY_gc
 */

#endif /* SLEEP_H */
