/**
 * \file
 *
 * \brief CLZ/CTZ C
 *
 * 쌠 (c) 2009 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CLZ_CTH_H
#define CLZ_CTH_H

/**
 * \brief ȂŐs0v
 *
 * ϸۂ͂ǂ̑傫̕ȂȂ傫pCLZ֐ւ̌Ăяo
 * ]܂B̊֐͐1OMSBŎn܂0̐𐔂܂B
 *
 * \param	x	s0𐔂镄Ȃ
 *
 * \return \a x̐s0̐
 */
#define clz(x)    compiler_demux_size(sizeof(x), clz, (x))

/**
 * \internal
 * \brief Ȃ8ޯĐŐs0v
 *
 * \param	x	s0𐔂镄Ȃ޲
 *
 * \return \a x̐s0̐
 */
__always_inline static uint8_t clz8(uint8_t x)
{
	uint8_t bit = 0;

	if (x & 0xf0) {
		x >>= 4;
	} else {
		bit += 4;
	}

	if (x & 0x0c) {
		x >>= 2;
	} else {
		bit += 2;
	}

	if (!(x & 0x02)) {
		bit++;
	}

	return bit;

}

/**
 * \internal
 * \brief Ȃ16ޯĐŐs0v
 *
 * \param	x	s0𐔂镄Ȃ
 *
 * \return \a x̐s0̐
 */
__always_inline static uint8_t clz16(uint16_t x)
{
	uint8_t bit = 0;

	if (x & 0xff00) {
		x >>= 8;
	} else {
		bit += 8;
	}

	return bit + clz8(x);
}

/**
 * \internal
 * \brief Ȃ32ޯĐŐs0v
 *
 * \param	x	s0𐔂镄Ȃ{
 *
 * \return \a x̐s0̐
 */
__always_inline static uint8_t clz32(uint32_t x)
{
	uint8_t bit = 0;

	if (x & 0xffff0000) {
		x >>= 16;
	} else {
		bit += 16;
	}

	return bit + clz16(x);
}

/**
 * \brief ȂŌs0v
 *
 * ϸۂ͂ǂ̑傫̕ȂȂ傫pCLZ֐ւ̌Ăяo
 * ]܂B̊֐͐1OLSBŎn܂0̐𐔂܂B
 *
 * \param	x	s0𐔂镄Ȃ
 *
 * \return \a x̌s0̐
 */
#define ctz(x)    compiler_demux_size(sizeof(x), ctz, (x))

/**
 * \internal
 * \brief Ȃ8ޯĐŌs0v
 *
 * \param	x	s0𐔂镄Ȃ޲
 *
 * \return \a x̌s0̐
 */
__always_inline static uint8_t ctz8(uint8_t x)
{
	uint8_t bit = 0;

	if (!(x & 0x0f)) {
		bit += 4;
		x >>= 4;
	}
	if (!(x & 0x03)) {
		bit += 2;
		x >>= 2;
	}
	if (!(x & 0x01))
		bit++;

	return bit;
}

/**
 * \internal
 * \brief Ȃ16ޯĐŌs0v
 *
 * \param	x	s0𐔂镄Ȃ
 *
 * \return \a x̌s0̐
 */
__always_inline static uint8_t ctz16(uint16_t x)
{
	uint8_t bit = 0;

	if (!(x & 0x00ff)) {
		bit += 8;
		x >>= 8;
	}

	return bit + ctz8(x);
}

/**
 * \internal
 * \brief Ȃ32ޯĐŌs0v
 *
 * \param	x	s0𐔂镄Ȃ{
 *
 * \return \a x̌s0̐
 */
__always_inline static uint8_t ctz32(uint32_t x)
{
	uint8_t bit = 0;

	if (!(x & 0x0000ffff)) {
		bit += 16;
		x >>= 16;
	}

	return bit + ctz16(x);
}

#endif /* CLZ_CTZ_H */
