/**
 * \file
 *
 * \brief ϳp֐
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include <asf.h>
#include "conf_usb.h"
#include "conf_usart_serial.h"
#include "ui.h"

int joystick_input_0,joystick_input_1,joystick_input_2,joystick_input_3;

static volatile bool main_b_mouse_enable = false;

/**
 * \brief ADC荞ݗpĂі߂֐
 *
 * \param	adc			ADCPʕւ̈ʒuwq
 * \param	channel		ADCٔԍ
 * \param	result		ADCق̕ϊ
 */
static void adc_handler(ADC_t *adc, uint8_t ch_mask, adc_result_t result)
{
	/*
	static uint8_t current_scan_channel = 0;
	// ADCʂʔzɊi[
	if (ch_mask & ADC_CH0) {
		adc_scan_results[current_scan_channel] = result;
		current_scan_channel++;
		// 8݂ꂽɑψʂ0Ɋۂ
		if (current_scan_channel == 4) {
			current_scan_channel = 0;
		}
	}

	*/

	switch(ch_mask){
		case 1:
				joystick_input_0 = result;
			break;
		case 2:
				joystick_input_1 = result;
			break;
		case 4:
				joystick_input_2 = result;
			break;
		case 8:
				joystick_input_3 = result;
			break;
	}

	#if (DEBUG)

	// ̺
	//printf("\n\r Joystick Input 1: %d",adc_scan_results[0]);

	//printf("\n\r Joystick Input 2: %d",joystick_input_1);
	//

	#endif
}


/*! \brief ֐AsJn
 */
int main(void)
{
	sysclk_init();
	irq_initialize_vectors();
	cpu_irq_enable();

	// x~Ǘ
	sleepmgr_init();

	board_init();
	#if (DEBUG)

	// ޯ ̪
	uart_debug_init();

	printf("\n\rNVIDIA DEMO\n\r");

	#endif

	ui_init();
	ui_powerdown();
	adc_hw_init(ADC_CH0,JOYSTICK_INPUT_0);
	adc_hw_init(ADC_CH1,JOYSTICK_INPUT_1);
	adc_hw_init(ADC_CH2,JOYSTICK_INPUT_2);
	adc_hw_init(ADC_CH3,JOYSTICK_INPUT_3);
	adc_enable(ADC_PORT_A);


	// VBUSĎF邽߂USBKwJn
	udc_start();

	if (!udc_include_vbus_monitoring()) {
		// ̐iVBUSĎpsAɂVBUS݂͑Ăƌ
		// Ȃ΂Ȃ܂B
		main_vbus_action(true);
	}

	// USBǗ荞݂ɂčs邽߁AJԂ͓d͓삾Ǘ
	// ܂B
	while (true) {
#ifdef   USB_DEVICE_LOW_SPEED
		// ϳ ̪𑖍̂ɒᑬŗp\USBŎ銄荞݂
		// ̂ŁAJԂgp܂B
		if (main_b_mouse_enable) {
			static volatile uint16_t virtual_sof_sub = 0;
			static uint16_t virtual_sof = 0;
			if (sysclk_get_cpu_hz()/50000 ==
				virtual_sof_sub++) {
				virtual_sof_sub = 0;
				static uint16_t virtual_sof = 0;
				ui_process(virtual_sof++);
			}
		}
#else
		sleepmgr_enter_sleep();
#endif

	}
}

void main_vbus_action(bool b_high)
{
	if (b_high) {
		// USBut
		udc_attach();
	} else {
		// VBUSs
		udc_detach();
	}
}

void main_suspend_action(void)
{
	ui_powerdown();
}

void main_resume_action(void)
{
	ui_wakeup();
}

void main_sof_action(void)
{
	if (!main_b_mouse_enable)
		return;
	ui_process(udd_get_frame_number());
}

void main_remotewakeup_enable(void)
{
	ui_wakeup_enable();
}

void main_remotewakeup_disable(void)
{
	ui_wakeup_disable();
}

bool main_mouse_enable(void)
{
	main_b_mouse_enable = true;
	return true;
}

void main_mouse_disable(void)
{
	main_b_mouse_enable = false;
}
/*****************************************************************************
֐	: uart_debug_init
	: ޯ ̪pUSART
Ұ	: Ȃ
Ԃ	: Ȃ
t	: 2012N628
*****************************************************************************/
void uart_debug_init(void){

	const usart_serial_options_t usart_serial_options =
	{
		.baudrate     = USART_SERIAL_EXAMPLE_BAUDRATE,
		.charlength   = USART_SERIAL_CHAR_LENGTH,
		.paritytype   = USART_SERIAL_PARITY,
		.stopbits     = USART_SERIAL_STOP_BIT
	};

	// STDIOײ؂pļر ̪
	stdio_serial_init(USART_SERIAL_EXAMPLE, &usart_serial_options);

	// STDOUTɏՂׂłȂƂw
	#if (defined(__GNUC__) && defined(__AVR32__))
	setbuf(stdout, NULL);
	#else // __ICCAVR32__
	// IAR̕WDLIB`Ԑݒł̏ꍇ: printf()͓1o
	#endif

	// 悤үޏo
	printf("\n\rDebug Interface Initialized\n\r");

	// STDINɏՂׂłȂƂw
	#if (defined(__GNUC__) && defined(__AVR32__))
	setbuf(stdin, NULL);
	#else // __ICCAVR32__
	// IAR̕WDLIB`Ԑݒł̏ꍇ
	#endif
}

/*****************************************************************************
֐	: adc_hw_init
	: ADC`Ԑݒݒ肷֐
Ұ	: Ȃ
Ԃ	: Ȃ
t	: 2011N58
*****************************************************************************/
void adc_hw_init(int ch,int pin){

	struct adc_config         adc_conf;
	struct adc_channel_config adcch_conf;

	// `Ԑݒ\̏
	adc_read_configuration(&ADCA, &adc_conf);
	adcch_read_configuration(&ADCA, ch, &adcch_conf);

	/* ADCPʕ`Ԑݒ:
	 * - Ȃ12ޯĂ̌
	 * - Vcc/1.6̊d
	 * - 200kHz̍őۯx
	 * - 蓮ϊN
	 * - xm틖
	 * - Ăі߂֐
	 */
	#if (RESOLUTION_SELECT == BIT_RESOLUTION_8 )
		adc_set_conversion_parameters(&adc_conf, ADC_SIGN_OFF, ADC_RES_8,
			ADC_REF_AREFA);
	#endif

	#if (RESOLUTION_SELECT == BIT_RESOLUTION_12 )
		adc_set_conversion_parameters(&adc_conf, ADC_SIGN_OFF, ADC_RES_12,
	ADC_REF_AREFA);
	#endif

	adc_set_clock_rate(&adc_conf, 200000UL);
		adc_set_conversion_trigger(&adc_conf, ADC_TRIG_MANUAL, 1, 0);

		/*
		adc_set_current_limit(&adc_conf, ADC_CURRENT_LIMIT_HIGH);
		adc_set_gain_impedance_mode(&adc_conf, ADC_GAIN_HIGHIMPEDANCE);
	//adc_enable_internal_input(&adc_conf, ADC_INT_TEMPSENSE);
	*/
	adc_write_configuration(&ADCA, &adc_conf);

	adc_set_callback(&ADCA, &adc_handler);

	/* ADC0`Ԑݒ:
	 * - xm킩̼ݸ ޑ
	 * - ϊŊ荞׸ސݒ
	 * - 荞݋֎~
	 */
	adcch_set_input(&adcch_conf,pin, ADCCH_NEG_NONE,
			1);
	adcch_set_interrupt_mode(&adcch_conf, ADCCH_MODE_COMPLETE);

	adcch_enable_interrupt(&adcch_conf);
	//adcch_set_pin_scan(&adcch_conf, 0, 4);  - ǂ@

	adcch_write_configuration(&ADCA, ch, &adcch_conf);

	/*
	// NƂĎgp悤Ɏۼт
	sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_EVSYS);
	// 62500/bϊ
	EVSYS.CH0MUX = EVSYS_CHMUX_PRESCALER_32768_gc;

	// ADC
	adc_enable(&ADCA);

	*/
}


/**
 * \mainpage ASF USBuHIDϽ
 *
 * \section intro 
 * ̗USBPʕAtmel MCUUSBuHIDϳ@܂B
 * AVR4903pLq̎ɂĂ̏񋟂܂B
 *
 * \section startup n
 * ͕WϳU邽߂Ɋŗp\ȖtƊmgp܂B̧ѳ
 * ݒA(EVKxx,Xplain`)USBνĂɐڑĂBUSBν тɐڑ
 * ƁẢpUnix/Mac/Windows̵ڰèݸ тϳp񋟂܂B
 * ̵̗͂ڰèݸ тɑ΂Ė{HIDײނgp܂B
 *
 * \copydoc UI
 *
 * \section example ɂ
 *
 * ͈ȉ̒PʕQgp܂B:
 * - {Pʕ:
 *   nAAۯA荞݁Ad͊Ǘ
 * - USBuKwHIDPʕ:
 *   <br>services/usb/
 *   <br>services/usb/udc/
 *   <br>services/usb/class/hid/
 *   <br>services/usb/class/hid/mouse/
 * - :
 *    - main.c,
 *      <br>ۯ
 *      <br>荞ݏ
 *      <br>UIǗ
 *    - eړIΏۂɑ΂ "./examples/product_board/":
 *       - conf_foo.h	ePʕ̌`Ԑݒ
 *       - ui.c 		gp҂̲̪(tALED)̎
 */
