/**
 * \file
 *
 * \brief USBulԲ̪u(HID)ϳ ̪
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udd.h"
#include "udc.h"
#include "udi_hid.h"
#include "udi_hid_mouse.h"
#include <string.h>

/**
 * \ingroup udi_hid_mouse_group
 * \defgroup udi_hid_mouse_group_udc USBuƂ̲̪(UDC)
 *
 * UDCɂĕKvƂ\̂Ɗ֐
 *
 * @{
 */
bool udi_hid_mouse_enable(void);
void udi_hid_mouse_disable(void);
bool udi_hid_mouse_setup(void);
uint8_t udi_hid_mouse_getsetting(void);

//! UDCpWUDI̪܂ޑS̍\
UDC_DESC_STORAGE udi_api_t udi_api_hid_mouse = {
	.enable = (bool(*)(void))udi_hid_mouse_enable,
	.disable = (void (*)(void))udi_hid_mouse_disable,
	.setup = (bool(*)(void))udi_hid_mouse_setup,
	.getsetting = (uint8_t(*)(void))udi_hid_mouse_getsetting,
	.sof_notify = NULL,
};
//@}


/**
 * \ingroup udi_hid_mouse_group
 * \defgroup udi_hid_mouse_group_internal UDI HIDϳ̎
 *
 * ׽
 * @{
 */

/**
 * \name HIDϳǗ̒`ƕϐ
 */
//@{

#define UDI_HID_MOUSE_REPORT_SIZE	4							//!< WHIDϳp񍐂̑傫
static uint8_t udi_hid_mouse_rate;								//!< HIDϳ̌ݑxi[p
static uint8_t udi_hid_mouse_protocol;							//!< HIDϳ̌݋Ki[p
static bool udi_hid_mouse_b_report_valid;						//!< Lȕ񍐂o̏ꍇ̍}p
static uint8_t udi_hid_mouse_report[UDI_HID_MOUSE_REPORT_SIZE];	//!< 񍐑o
static bool udi_hid_mouse_report_trans_ongoing;					//!< 񍐓]is̏ꍇ}
COMPILER_WORD_ALIGNED											//!< 񍐑oɎgpɏՕ
		static uint8_t
		udi_hid_mouse_report_trans[UDI_HID_MOUSE_REPORT_SIZE];


/**
 * \brief SETUPvpĂі߂
 *
 * \return	ϳ ̪ŎgpȂߏ\c 1
 */
static bool udi_hid_mouse_setreport(void);

//@}

//! WHIDϳpHID񍐋Lqq
UDC_DESC_STORAGE udi_hid_mouse_report_desc_t udi_hid_mouse_report_desc = {
	{
		0x05, 0x01,		// gp(޽į),
		0x09, 0x02,		// gp(ϳ),
		0xA1, 0x01,		//  W(p),
		0x09, 0x01,		//   gp(߲),
		0xA1, 0x00,		//  W(),
		0x05, 0x09,		//     gp(t),
		0x19, 0x01,		//     gpŏ(01),
		0x29, 0x03,		//     gpő(03),
		0x15, 0x00,		//     _ŏ(0),
		0x25, 0x01,		//     _ő(1),
		0x75, 0x01,		//     񍐗(1),
		0x95, 0x03,		//     񍐐(3),
		0x81, 0x02,		//     (ްAϐA),
		0x75, 0x05,		//     񍐗(5),
		0x95, 0x01,		//     񍐐(1),
		0x81, 0x01,		//     (萔),
		0x05, 0x01,		//     gp(޽į),
		0x09, 0x30,		//     gp(X),
		0x09, 0x31,		//     gp(Y),
		0x09, 0x38,		//     gp(۰),
		0x15, 0x81,		//     _ŏ(-127),
		0x25, 0x7F,		//     _ő(127),
		0x75, 0x08,		//     񍐗(8),
		0x95, 0x03,		//     񍐐(3),
		0x81, 0x06,		//     (ްAϐA),
		0xC0,			//  WI,
		0xC0,			// WI
	}
};

/**
 * \name ٰ
 */
//@{

/**
 * \brief ړ
 *
 * \param	pos				ړ镄l
 * \param	index_report	ړ񍐂̎wW
 *							(3=۰ٗցA2=YA1=X)
 *
 * \return	֐I\c 1AȂ\c 0
 */
static bool udi_hid_mouse_move(int8_t pos, uint8_t index_report);

/**
 * \brief tԕω
 *
 * \param	b_state		Vt
 * \param	btn			ςt̎wW(4=A2=EA1=)
 *
 * \return	֐I\c 1AȂ\c 0
 */
static bool udi_hid_mouse_btn(bool b_state, uint8_t btn);

/**
 * \brief 񍐑o
 *
 * \return	ois\c 1Ax\c 0
 */
static bool udi_hid_mouse_send_report(void);

/**
 * \brief 񍐑oɌĂ΂Ăі߂
 *
 * \param	status		]IȂAUDD_EP_TRANSFER_OK
 * \param	status		]fȂAUDD_EP_TRANSFER_ABORT
 * \param	nb_sent		]ް
 *
 * \return	֐I\c 1AȂ\c 0
 */
void udi_hid_mouse_report_sent(udd_ep_status_t status, iram_size_t nb_sent);

//@}


//--------------------------------------------
//------ UDI HIDٗp̪

bool udi_hid_mouse_enable(void)
{
	// l
	udi_hid_mouse_rate = 0;
	udi_hid_mouse_protocol = 0;
	udi_hid_mouse_report_trans_ongoing = false;
	memset(udi_hid_mouse_report, 0, UDI_HID_MOUSE_REPORT_SIZE);
	udi_hid_mouse_b_report_valid = false;
	return UDI_HID_MOUSE_ENABLE_EXT();
}


void udi_hid_mouse_disable(void)
{
	UDI_HID_MOUSE_DISABLE_EXT();
}


bool udi_hid_mouse_setup(void)
{
	return udi_hid_setup(&udi_hid_mouse_rate,
								&udi_hid_mouse_protocol,
								(uint8_t *) &udi_hid_mouse_report_desc,
								udi_hid_mouse_setreport);
}


uint8_t udi_hid_mouse_getsetting(void)
{
	return 0;
}


static bool udi_hid_mouse_setreport(void)
{
	return false;
}


//--------------------------------------------
//------ pp̪

bool udi_hid_mouse_moveScroll(int8_t pos)
{
	return udi_hid_mouse_move(pos, 3);
}

bool udi_hid_mouse_moveY(int8_t pos_y)
{
	return udi_hid_mouse_move(pos_y, 2);
}

bool udi_hid_mouse_moveX(int8_t pos_x)
{
	return udi_hid_mouse_move(pos_x, 1);
}

bool udi_hid_mouse_btnmiddle(bool b_state)
{
	return udi_hid_mouse_btn(b_state, 0x04);
}

bool udi_hid_mouse_btnright(bool b_state)
{
	return udi_hid_mouse_btn(b_state, 0x02);
}

bool udi_hid_mouse_btnleft(bool b_state)
{
	return udi_hid_mouse_btn(b_state, 0x01);
}


//--------------------------------------------
//------ ٰ

static bool udi_hid_mouse_move(int8_t pos, uint8_t index_report)
{
	int16_t s16_newpos;

	irqflags_t flags = cpu_irq_save();

	// HIDϳ񍐂ňʒuǉ
	s16_newpos = (int8_t) udi_hid_mouse_report[index_report];
	s16_newpos += pos;
	if ((-127 > s16_newpos) || (127 < s16_newpos)) {
		cpu_irq_restore(flags);
		return false;	// 񍐈
	}
	udi_hid_mouse_report[index_report] = (uint8_t) s16_newpos;

	// Lŕ񍐑o
	udi_hid_mouse_b_report_valid = true;
	udi_hid_mouse_send_report();

	cpu_irq_restore(flags);
	return true;
}


static bool udi_hid_mouse_btn(bool b_state, uint8_t btn)
{
	// ύXt
	if (HID_MOUSE_BTN_DOWN == b_state)
		udi_hid_mouse_report[0] |= btn;
	else
		udi_hid_mouse_report[0] &= ~btn;
	// ϳړٰ݂gp
	return udi_hid_mouse_move(0, 1);
}


static bool udi_hid_mouse_send_report(void)
{
	if (udi_hid_mouse_report_trans_ongoing)
		return false;	// ]isA]ɂ𑗏o

	// ]̂߂ɂgp鑼̔zɕ񍐂𕡎
	memcpy(udi_hid_mouse_report_trans, udi_hid_mouse_report,
			UDI_HID_MOUSE_REPORT_SIZE);
	memset(&udi_hid_mouse_report[1], 0, 3);	// ̕񍐗pɖt̏Ԃێ
	udi_hid_mouse_b_report_valid = false;

	// 񍐑o
	udi_hid_mouse_report_trans_ongoing =
			udd_ep_run(	UDI_HID_MOUSE_EP_IN,
							false,
							udi_hid_mouse_report_trans,
							UDI_HID_MOUSE_REPORT_SIZE,
							udi_hid_mouse_report_sent);
	return udi_hid_mouse_report_trans_ongoing;
}


void udi_hid_mouse_report_sent(udd_ep_status_t status, iram_size_t nb_sent)
{
	// Lȕ񍐑o
	udi_hid_mouse_report_trans_ongoing = false;
	if (udi_hid_mouse_b_report_valid) {
		// VLbȕ񍐂𑗏o
		udi_hid_mouse_send_report();
	}
}

//@}
