/**
 * \file
 *
 * \brief P̪HIDϳUSBupLqq
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "udd.h"
#include "udc_desc.h"
#include "udi_hid.h"
#include "udi_hid_mouse.h"

/**
 * \ingroup udi_hid_mouse_group
 * \defgroup udi_hid_mouse_group_single_desc P̪pUSBuLqq
 *
 * ȉ̍\̂͒P̪HIDϳUSBuɕKvƂUSBuLqq
 * ܂B
 *
 * ͎gpĂčXȂ`̕Kv͂܂B
 *
 * @{
 */

//! ̑uɑ΂1̲̪
#define  USB_DEVICE_NB_INTERFACE	1

//! USBuLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE usb_dev_desc_t udc_device_desc = {
	.bLength					= sizeof(usb_dev_desc_t),
	.bDescriptorType			= USB_DT_DEVICE,
	.bcdUSB						= LE16(USB_V2_0),
	.bDeviceClass				= 0,
	.bDeviceSubClass			= 0,
	.bDeviceProtocol			= 0,
	.bMaxPacketSize0			= USB_DEVICE_EP_CTRL_SIZE,
	.idVendor					= LE16(USB_DEVICE_VENDOR_ID),
	.idProduct					= LE16(USB_DEVICE_PRODUCT_ID),
	.bcdDevice					= LE16((USB_DEVICE_MAJOR_VERSION << 8)
		| USB_DEVICE_MINOR_VERSION),
#ifdef USB_DEVICE_MANUFACTURE_NAME
	.iManufacturer				= 1,
#else
	.iManufacturer				= 0,	// ƎҕȂ
#endif
#ifdef USB_DEVICE_PRODUCT_NAME
	.iProduct					= 2,
#else
	.iProduct					= 0,	// iȂ
#endif
#ifdef USB_DEVICE_SERIAL_NAME
	.iSerialNumber				= 3,
#else
	.iSerialNumber				= 0,	// ʔԕȂ
#endif
	.bNumConfigurations			= 1
};


#ifdef USB_DEVICE_HS_SUPPORT
//! HSpUSBuCqLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE usb_dev_qual_desc_t udc_device_qual = {
	.bLength					= sizeof(usb_dev_qual_desc_t),
	.bDescriptorType			= USB_DT_DEVICE_QUALIFIER,
	.bcdUSB						= LE16(USB_V2_0),
	.bDeviceClass				= 0,
	.bDeviceSubClass			= 0,
	.bDeviceProtocol			= 0,
	.bMaxPacketSize0			= USB_DEVICE_EP_CTRL_SIZE,
	.bNumConfigurations			= 1
};
#endif

//! USBu`ԐݒLqqp\
COMPILER_PACK_SET(1);
typedef struct {
	usb_conf_desc_t conf;
	udi_hid_mouse_desc_t hid_mouse;
} udc_desc_t;
COMPILER_PACK_RESET();

//! FSHSpɖꂽUSBu`ԐݒLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE udc_desc_t udc_desc = {
	.conf.bLength				= sizeof(usb_conf_desc_t),
	.conf.bDescriptorType		= USB_DT_CONFIGURATION,
	.conf.wTotalLength			= LE16(sizeof(udc_desc_t)),
	.conf.bNumInterfaces		= USB_DEVICE_NB_INTERFACE,
	.conf.bConfigurationValue	= 1,
	.conf.iConfiguration		= 0,
	.conf.bmAttributes			= USB_CONFIG_ATTR_MUST_SET | USB_DEVICE_ATTR,
	.conf.bMaxPower				= USB_CONFIG_MAX_POWER(USB_DEVICE_POWER),
	.hid_mouse					= UDI_HID_MOUSE_DESC,
};


/**
 * \name SĂUSBu`܂UDC\
 */
//@{

//! eUSB̪ɑ΂UDI֘At
UDC_DESC_STORAGE udi_api_t *udi_apis[USB_DEVICE_NB_INTERFACE] = {
	&udi_api_hid_mouse,
};

//! FSHSUSBLqqƋUDIǉ
UDC_DESC_STORAGE udc_config_speed_t udc_config_fshs[1] = { {
	.desc          = (usb_conf_desc_t UDC_DESC_STORAGE*)&udc_desc,
	.udi_apis      = udi_apis,
}};

//! UDBpS̍\̂USBuɂĂ̑Sǉ
UDC_DESC_STORAGE udc_config_t udc_config = {
	.confdev_lsfs = &udc_device_desc,
	.conf_lsfs = udc_config_fshs,
#ifdef USB_DEVICE_HS_SUPPORT
	.confdev_hs = &udc_device_desc,
	.qualifier = &udc_device_qual,
	.conf_hs = udc_config_fshs,
#endif
};

//@}
//@}
