/**
 * \file
 *
 * \brief USBu̪pAPI
 *
 * 쌠 (c) 2009 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDC_DESC_H_
#define _UDC_DESC_H_

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udi.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup udc_group
 * \defgroup udc_desc_group USBuLqq
 *
 * @{
 */

/**
 * \brief USBLqq؂̈ʒu`
 *
 * ɂċLqqRAMɊi[܂B
 * (UDC_DESC_STORAGE͋ɒ`܂B)
 *
 * RAMԂ̕KvȂAȉ̏ꍇɋLqqׯɒuƂ\łB:
 * - USBײނׯ]F(UC3USBBmegeAVRUSB)
 * - USBułȂ(UDCUSBLqύXsv)
 *
 * "const"gpUC3pɂ
 *
 * "code"gpmegaAVRpɂ
 */
#define  UDC_DESC_STORAGE
	// RAMł̋LqqL
#if (defined UDC_DATA_USE_HRAM_SUPPORT)
#	if defined(__GNUC__)
#		define UDC_DATA(x)              COMPILER_WORD_ALIGNED __attribute__((__section__(".data_hram0")))
#		define UDC_BSS(x)               COMPILER_ALIGNED(x)   __attribute__((__section__(".bss_hram0")))
#	elif defined(__ICCAVR32__)
#		define UDC_DATA(x)              COMPILER_ALIGNED(x)   __data32
#		define UDC_BSS(x)               COMPILER_ALIGNED(x)   __data32
#	endif
#else
#	define UDC_DATA(x)              COMPILER_ALIGNED(x)
#	define UDC_BSS(x)               COMPILER_ALIGNED(x)
#endif


/**
 * \brief 1USBxɑ΂`ԐݒLqqUSIڑ
 */
typedef struct {
	//! USB`ԐݒLqq
	usb_conf_desc_t UDC_DESC_STORAGE *desc;
	//! UDI APIʒuwq̔z
	udi_api_t UDC_DESC_STORAGE *UDC_DESC_STORAGE * udi_apis;
} udc_config_speed_t;


/**
 * \brief USBuɂĂ̑S
 */
typedef struct {
	//! ᑬƑSpUSBuLqq
	usb_dev_desc_t UDC_DESC_STORAGE *confdev_lsfs;
	//! ᑬƑSpUSB`ԐݒLqqUDI APIʒuwq
	udc_config_speed_t UDC_DESC_STORAGE *conf_lsfs;
#ifdef USB_DEVICE_HS_SUPPORT
	//! pUSBuLqq
	usb_dev_desc_t UDC_DESC_STORAGE *confdev_hs;
	//! USBuCqAł̂ݎgp
	usb_dev_qual_desc_t UDC_DESC_STORAGE *qualifier;
	//! pUSB`ԐݒLqqUDI APIʒuwq
	udc_config_speed_t UDC_DESC_STORAGE *conf_hs;
#endif
} udc_config_t;

//! USBuLqq̑S̕ϐUSIڑ
extern UDC_DESC_STORAGE udc_config_t udc_config;

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDC_DESC_H_
