/**
 * \file
 *
 * \brief AVR XMEGApUSARTײ
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <stdint.h>

#include "compiler.h"
#include "usart.h"
#include "sysclk.h"
#include "ioport.h"
#include "status_codes.h"

/**
 * \brief USARTPʕɑ΂ļ ۯ
 *
 * ̊֐͒񋟂ꂽ\arg usartPʕɼ ۯ܂B
 *
 * \brief	usart	USARTPʕւ̈ʒuwq
 */
static inline void usart_enable_module_clock(USART_t *usart)
{
#ifdef USARTC0
	if ((uintptr_t)usart == (uintptr_t)&USARTC0) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_USART0);
	}
#endif
#ifdef USARTC1
	if ((uintptr_t)usart == (uintptr_t)&USARTC1) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_USART1);
	}
#endif
#ifdef USARTD0
	if ((uintptr_t)usart == (uintptr_t)&USARTD0) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_USART0);
	}
#endif
#ifdef USARTD1
	if ((uintptr_t)usart == (uintptr_t)&USARTD1) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_USART1);
	}
#endif
#ifdef USARTE0
	if ((uintptr_t)usart == (uintptr_t)&USARTE0) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_USART0);
	}
#endif
#ifdef USARTE1
	if ((uintptr_t)usart == (uintptr_t)&USARTE1) {
		sysclk_enable_module(SYSCLK_PORT_E, SYSCLK_USART1);
	}
#endif
#ifdef USARTF0
	if ((uintptr_t)usart == (uintptr_t)&USARTF0) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_USART0);
	}
#endif
#ifdef USARTF1
	if ((uintptr_t)usart == (uintptr_t)&USARTF1) {
		sysclk_enable_module(SYSCLK_PORT_F, SYSCLK_USART1);
	}
#endif
}

/**
 * \brief RS232USART
 *
 * ̊֐usart_rs232_options_t`Ԑݒ\̂CPUgpUSARTPʕ
 * RS232ŏ܂B
 *
 * \param	usart	USARTPʕ
 * \param	opt		RS232`ԐݒCӑI
 *
 * \retval	true	ꍇ
 * \retval	false	s(ްڰČvZňُ)̏ꍇ
 */
bool usart_init_rs232(USART_t *usart, const usart_rs232_options_t *opt)
{
	bool result;
	usart_enable_module_clock(usart);
	usart_set_mode(usart, USART_CMODE_ASYNCHRONOUS_gc);
	usart_format_set(usart, opt->charlength, opt->paritytype,
			opt->stopbits);
	result = usart_set_baudrate(usart, opt->baudrate, sysclk_get_per_hz());
	usart_tx_enable(usart);
	usart_rx_enable(usart);
	
	return result;
}

/**
 * \brief SPI呕uUSART
 *
 * ̊֐usart_spi_options_t`Ԑݒ\̂CPUgpUSARTPʕ
 * SPI呕uɏ܂B
 *
 * \param	usart	USARTPʕ
 * \param	opt		SPI呕u`ԐݒCӑI
 */
void usart_init_spi(USART_t *usart, const usart_spi_options_t *opt)
{
	usart_enable_module_clock(usart);
	usart_set_mode(usart, USART_CMODE_MSPI_gc);
	port_pin_t sck_pin;

	if (opt->spimode == 1 || opt->spimode == 3) {
		/** \todo ͯ ̧قUCPHA_bmǉ鎞ɏC */
		usart->CTRLC |= 0x02;
	} else {
		/** \todo ͯ ̧قUCPHA_bmǉ鎞ɏC */
		usart->CTRLC &= ~0x02;
	}

	/* SCK I/O߰ĂINVENޯĂpĸۯɐ`Ԑݒ **/
	if (opt->spimode == 2 || opt->spimode == 3) {
#ifdef USARTC0
		if ((uint16_t)usart == (uint16_t)&USARTC0) {
			sck_pin = IOPORT_CREATE_PIN(PORTC, 1);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTC1
		if ((uint16_t)usart == (uint16_t)&USARTC1) {
			sck_pin = IOPORT_CREATE_PIN(PORTC, 5);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTD0
		if ((uint16_t)usart == (uint16_t)&USARTD0) {
			sck_pin = IOPORT_CREATE_PIN(PORTD, 1);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTD1
		if ((uint16_t)usart == (uint16_t)&USARTD1) {
			sck_pin = IOPORT_CREATE_PIN(PORTD, 5);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTE0
		if ((uint16_t)usart == (uint16_t)&USARTE0) {
			sck_pin = IOPORT_CREATE_PIN(PORTE, 1);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTE1
		if ((uint16_t)usart == (uint16_t)&USARTE1) {
			sck_pin = IOPORT_CREATE_PIN(PORTE, 5);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTF0
		if ((uint16_t)usart == (uint16_t)&USARTF0) {
			sck_pin = IOPORT_CREATE_PIN(PORTF, 1);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
#ifdef USARTF1
		if ((uint16_t)usart == (uint16_t)&USARTF1) {
			sck_pin = IOPORT_CREATE_PIN(PORTF, 5);
			ioport_configure_port_pin(ioport_pin_to_port(sck_pin),
					ioport_pin_to_mask(sck_pin),
					IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH |
					IOPORT_INV_ENABLED);
		}
#endif
	}

	usart_spi_set_baudrate(usart, opt->baudrate, sysclk_get_per_hz());
	usart_tx_enable(usart);
	usart_rx_enable(usart);
}

/**
 * \brief USARTPʕްo
 *
 * ̊֐USARTPʕpްo͂܂B
 *
 * \param	usart	USARTPʕ
 * \param	c		ް
 *
 * \return STATUS_OK
 */
enum status_code usart_putchar(USART_t *usart, uint8_t c)
{
	while (usart_data_register_is_empty(usart) == false) {
	}

	(usart)->DATA = c;
	return STATUS_OK;
}

/**
 * \brief USARTPʕް󂯎
 *
 * ̊֐USARTPʕŎ󂯎ްԂ܂B
 *
 * \param	usart	USARTPʕ
 *
 * \return 󂯎ް
 */
uint8_t usart_getchar(USART_t *usart)
{
	while (usart_rx_is_complete(usart) == false) {
	}

	return ((uint8_t)(usart)->DATA);
}

/**
 * \brief ްڰĕ\ŎQƗpψʂ擾
 *
 * \param	baud	vꂽްڰ
 *
 * \return The baudrate offset in PROGMEM\łްڰĕψ
 * \retval Qƕ\ްڰĂȂꍇUSART_BAUD_UNDEFINED
 */
static uint8_t usart_get_baud_offset(uint32_t baud)
{
	switch (baud) {
	case 1200:
		return (uint8_t)USART_BAUD_1200;

	case 2400:
		return (uint8_t)USART_BAUD_2400;

	case 4800:
		return (uint8_t)USART_BAUD_4800;

	case 9600:
		return (uint8_t)USART_BAUD_9600;

	case 19200:
		return (uint8_t)USART_BAUD_19200;

	case 38400:
		return (uint8_t)USART_BAUD_38400;

	case 57600:
		return (uint8_t)USART_BAUD_57600;

	default:
		return (uint8_t)USART_BAUD_UNDEFINED;
	}
}

/**
 * \brief USARTBSELBSCALL̒lݒ肷邱ƂɂްڰĂݒ
 *
 * ̊֐BSCALE 0BAUDCTRLڼ޽ɑIBSELBSCALE̒lݒ肵܂B
 * vZCӑIɂĂXMEGA A̕\21-1.B
 *
 * \param	usart	USARTPʕ
 * \param	bsel	vZBSELl
 * \param	bscale	vZBSCALEl
 *
 */
void usart_set_bsel_bscale_value(USART_t *usart, uint16_t bsel, uint8_t bscale)
{
	(usart)->BAUDCTRLA = (uint8_t)(bsel);
	(usart)->BAUDCTRLB = (uint8_t)(((bsel >> 8) & 0X0F) | (bscale << 4));
}

/**
 * \brief PROGMEM\ߌvZꂽBAUDCTRLlpްڰĂݒ
 *
 * \note ̊֐2MHz܂32MHzcpu_hz1200,2400,4800,9600,19200,38400,
 * 57600ްڰĒlɑ΂Ă܂B
 *
 * \param	usart	USARTPʕ
 * \param	baud	ްڰ
 * \param	cpu_hz	CPUg
 *
 */
void usart_set_baudrate_precalculated(USART_t *usart, uint32_t baud,
		uint32_t cpu_hz)
{
	uint8_t baud_offset;
	uint16_t baudctrl = 0;

	baud_offset = usart_get_baud_offset(baud);

	if (cpu_hz == 2000000UL) {
		baudctrl = PROGMEM_READ_WORD(baudctrl_2mhz + baud_offset);
	} else if (cpu_hz == 32000000UL) {
		baudctrl = PROGMEM_READ_WORD(baudctrl_32mhz + baud_offset);
	} else {
		/* A ۯx܂USARTްڰĂQƕ\Ŏx܂B */
		Assert(false);
	}

	if (baud_offset != USART_BAUD_UNDEFINED) {
		(usart)->BAUDCTRLB = (uint8_t)((uint16_t)baudctrl);
		(usart)->BAUDCTRLA = (uint8_t)((uint16_t)baudctrl >> 8);
	}
}

/**
 * \brief USARTPʕްڰĒlݒ
 *
 * ̊֐CPUgɑ΂kڂްڰĂʰ޳ɂĎx邱ƕۏ؂
 * 邱Ƃްڰ ڼ޽ݒ肵܂B֐͂Ȃg̐ݒvZȂA
 * ͑sްڰĕύXKvƂꍇɎgp邱Ƃł܂B
 *
 * \param	usart	USARTPʕ
 * \param	baud	ްڰ
 * \param	cpu_hz	CPUg
 *
 * \retval	true	ʰ޳ްڰĂgpꍇ
 * \retval	false	ʰ޳ްڰĂxȂ(AႷ̂ǂ炩)
 *					ꍇ
 */
bool usart_set_baudrate(USART_t *usart, uint32_t baud, uint32_t cpu_hz)
{
	int8_t exp;
	uint32_t div;
	uint32_t limit;
	uint32_t ratio;
	uint32_t min_rate;
	uint32_t max_rate;

	/*
	 * ʰ޳^ꂽްڰĂx邩
	 */
	/* 8 = (2^0) * 8 * (2^0) = (2^BSCALE_MIN) * 8 * (BSEL_MIN) */
	max_rate = cpu_hz / 8;
	/* 4194304 = (2^7) * 8 * (2^12) = (2^BSCALE_MAX) * 8 * (BSEL_MAX+1) */
	min_rate = cpu_hz / 4194304;

	if (!((usart)->CTRLB & USART_CLK2X_bm)) {
		max_rate /= 2;
		min_rate /= 2;
	}

	if ((baud > max_rate) || (baud < min_rate)) {
		return false;
	}

	/* {邩 */
	if (!((usart)->CTRLB & USART_CLK2X_bm)) {
		baud *= 2;
	}

	/* \ȍŒ̎wT */
	limit = 0xfffU >> 4;
	ratio = cpu_hz / baud;

	for (exp = -7; exp < 7; exp++) {
		if (ratio < limit) {
			break;
		}

		limit <<= 1;

		if (exp < -3) {
			limit |= 1;
		}
	}

	/*
	 * w̒lɉāA͎g܂͖ړIΏްڰĂ̂ǂ炩ړx
	 * BɌɎړx邱ƂɂAtIȕsmĂ
	 * ܂B
	 *
	 * ǂ̓_ł2**32𒴂ȂƂۏ؂邽߁ȂōŏII(E
	 * 3ޯĈړƂĂm)8ł̏Z܂݂܂B
	 *
	 * BSELvZ鎮͎w̎ɑ΂Ďw̎ɋ͂ɈقȂ܂B
	 */
	if (exp < 0) {
		/* 1ZxǍBSCALE܂BŏBSCALE邱
		 * ]݁ÂɊʓ̑SĒP̕ɕςKv܂B
		 */
		cpu_hz -= 8 * baud;

		/* ōŌ8ł̏ZlČǍړꍇAZ̑OɈړs
		 * ܂BȂ΁Aɕړ܂(S̓IȉE
		 * ɋA܂)B
		 */
		if (exp <= -3) {
			div = ((cpu_hz << (-exp - 3)) + baud / 2) / baud;
		} else {
			baud <<= exp + 3;
			div = (cpu_hz + baud / 2) / baud;
		}
	} else {
		/* ̏ꍇł͏ɉEړs܂A8ł̏Ẑ߁A3̒ǉʒu
		 * KvłB
		 */
		baud <<= exp + 3;
		div = (cpu_hz + baud / 2) / baud - 1;
	}

	(usart)->BAUDCTRLB = (uint8_t)(((div >> 8) & 0X0F) | (exp << 4));
	(usart)->BAUDCTRLA = (uint8_t)div;

	return true;
}

/**
 * \brief USART_SPIPʕɰڰĒlݒ
 *
 * ̊֐CPUgɑ΂ްڰ ڼ޽ݒ肵܂B
 *
 * \param	usart	USART(SPI)Pʕ
 * \param	baud	ްڰ
 * \param	cpu_hz	CPUg
 */
void usart_spi_set_baudrate(USART_t *usart, uint32_t baud, uint32_t cpu_hz)
{
	uint16_t bsel_value;

	/* ްڰĂް-ĂŎwrꂽႢ */
	if (baud < (cpu_hz / 2)) {
		bsel_value = (cpu_hz / (baud * 2)) - 1;
	} else {
		/* ްڰĂްĂł̎dlłȂꍇA݂CPUgŉ\ȍőް
		 * ڰĂ蓖 */
		bsel_value = 0;
	}

	(usart)->BAUDCTRLB = (uint8_t)((~USART_BSCALE_gm) & (bsel_value >> 8));
	(usart)->BAUDCTRLA = (uint8_t)(bsel_value);
}
