/**
 * \file
 *
 * \brief USBuײ
 * ײUDD
 *
 * 쌠 (c) 2011 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"

// ǂ-ύX-ߺނIAR AVR 5.51Ɏ܂B
#ifdef __ICCAVR__
#  if (__VER__ <= 551 || XMEGA_A1U)
#    undef   USB_WORKAROUND_DO_NOT_USE_RMW
#    define  USB_WORKAROUND_DO_NOT_USE_RMW
#  endif
#endif

#include "sysclk.h"
#include "udd.h"
#include "usb_device.h"
#include <string.h>

#ifndef UDD_NO_SLEEP_MGR
#include "sleepmgr.h"
#endif

#ifndef UDD_USB_INT_LEVEL
// ɂAUSB荞݂͒D挠܂B
#  define UDD_USB_INT_LEVEL USB_INTLVL_LO_gc
#endif


#ifdef USB_DEVICE_HS_SUPPORT
#error   This product does not support high speed mode, please remove define USB_DEVICE_HS_SUPPORT in conf_usb.h
#endif

////////////////////////////////////////////////////
//    USBBuײ(UDD)
////////////////////////////////////////////////////
/**
 * \ingroup udd_group
 * \defgroup udd_xmega_usb_group XMEGA USBuײ
 *
 * \section USBB_CONF USBBƎ`Ԑݒ
 * ȉUSBBײތ`Ԑݒ͉pconf_usb.ḩق܂܂Ȃ΂Ȃ܂B
 *
 * UDD_USB_INT_LEVEL<br>
 * USB_INTLVL_LO_gc()ɂĊ荞ݗD挠ύXCӑI
 * (USB_INTLVL_x_gc)
 *
 * \section Ăі߂Ǘ
 * USBײނ͊荞݂ɂĊSɊǗAIȍƂv܂B
 * ɂAUSBۂ͏]̂ɌĂі߂gp܂BĂі߂ͺْ߲
 * ŐÓIɁA܂ͺގs̕ϐŐ錾܂B
 *
 * conf_usb.hŒ`ÓI錾:
 * - UDC_VBUS_EVENT(bool b_present)<br>
 *   VBUSٕύX}̂
 * - UDC_SUSPEND_EVENT()<br>
 *   USB޽ꎞx~ֈڍs鎞ɌĂ΂܂B
 * - UDC_RESUME_EVENT()<br>
 *   USB޽Nオ鎞ɌĂ΂܂B
 * - UDC_SOF_EVENT()<br>
 *   eSOFMɑ΂ČĂ΂܂B: HS/FS삾Ŋe1ms
 *
 * "߲č"ƌĂ΂铮IĂі߂͈ȉ̊֐oRin udd_ep_job_t\
 * œo^܂B:
 * - udd_ep_run()<br>
 *   ]IɂĂԂ
 * - udd_ep_wait_stall_clear()<br>
 *   ߲Ē~֎~鎞ɂĂԂ
 *
 * \section d͓Ǘ
 * Fꂽx~:
 * - USB IDLEԂł́AUSBUSBۯKvƂAIDLE܂łF܂B
 * - USB SUSPENDԂł́AUSBUSBۯKvƂ܂AŏۯĎnݸނ
 *   v܂B̂ɁAPOWER_DOWNSTANDBY܂łF܂B
 *
 * USB_SLEEP_MODE_USB_IDLESLEEPMGR_IDLEƓ
 *
 * USB_SLEEP_MODE_USB_SUSPENDUSBۯnݸނɈˑ:
 * | ۯn | Fx~ |
 * | >10ms    | SLEEPMGR_STDBY     |
 * | <=10ms   | SLEEPMGR_PDOWN     |
 *
 * @{
 */


// USBu`Ԑݒ蒲
#ifndef USB_DEVICE_EP_CTRL_SIZE
#  error USB_DEVICE_EP_CTRL_SIZE not defined
#endif
#ifndef USB_DEVICE_MAX_EP
#  error USB_DEVICE_MAX_EP not defined
#endif


/**
 * \name d͊Ǘٰ
 */
//@{


#ifndef UDD_NO_SLEEP_MGR

//! x~̒`
#if ((defined USB_DEVICE_HS_SUPPORT) && (USBCLK_STARTUP_TIMEOUT>3000)) \
 || ((!defined USB_DEVICE_HS_SUPPORT) && (USBCLK_STARTUP_TIMEOUT>10000))
#  define USBC_SLEEP_MODE_USB_SUSPEND  SLEEPMGR_IDLE
#else
#  define USBC_SLEEP_MODE_USB_SUSPEND  SLEEPMGR_PDOWN
#endif
#define USBC_SLEEP_MODE_USB_IDLE  SLEEPMGR_IDLE

//! USB̏
static bool udd_b_idle;


/*! \brief CPUܰ޳ݓFۂ
 *
 * \param	b_enable	ܰ޳ݓFɂtrue
 */
static void udd_sleep_mode(bool b_idle)
{
	if (!b_idle && udd_b_idle) {
		sleepmgr_unlock_mode(USBC_SLEEP_MODE_USB_IDLE);
	}
	if (b_idle && !udd_b_idle) {
		sleepmgr_lock_mode(USBC_SLEEP_MODE_USB_IDLE);
	}
	udd_b_idle = b_idle;
}
#else

static void udd_sleep_mode(bool b_idle) {
}
#endif  // UDD_NO_SLEEP_MGR

//@}

/**
 * \brief FIFOA߲ċLqq\AڰєԍɂĂUSB SRAMް
 *
 * USB SRAM̓e͈ȉsƂł܂B:
 * - ߲ďԂ}邽߂ɲ̪USBʰ޳ɂύXBɂA
 *   ĳɂǂݍ݁B
 * - ߲Ă𐧌䂷邽߂USBĳɂύXBɂAʰ޳ɂ
 *   ݍ݁B
 * ް̈͊œ̓ǂ/ύX/ߺނgpȂ΂Ȃ܂
 * B
 *
 * @{
 */
struct udd_sram_data {
#if XMEGA_A1U
#  if (0!=((USB_DEVICE_MAX_EP+1)%4))
	uint8_t padding_align[16 - ((USB_DEVICE_MAX_EP + 1) *
					sizeof(uint32_t)) % 16];
#  endif
#endif
	uint32_t fifo[USB_DEVICE_MAX_EP + 1];
	USB_EP_t ep_ctrl[2 * (USB_DEVICE_MAX_EP + 1)];
	uint16_t frame_number;
};
#if XMEGA_A1U
COMPILER_ALIGNED(16)
#else
COMPILER_ALIGNED(4)		//! ӁAGCC2̐𐳂Ȃ悤łB
#endif
static volatile struct udd_sram_data udd_sram;
#define UDD_EP_t  USB_EP_t volatile

// @}

/**
 * \name ߲Ă̏
 */
//@{
/**
 * \brief ߲Ă̌`ԐݒƋ
 *
 * \param	ep					(USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 * \param	bmAttributes		LqqŐ錾߲Ă̑
 * \param	MaxEndpointSize		߲Ă̍ő̑傫
 */
static void udd_ep_init(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize);

/**
 * \brief ߲ĔԍɑΉ߲ĐSRAM̈ʒuwqԂ܂B
 *
 * \param	ep	(USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 *
 * \return ߲ċLqqwW
 */
static UDD_EP_t *udd_ep_get_ctrl(udd_ep_id_t ep);
//@}


/**
 * \name ߲ĒʊǗٰ
 *
 * ̊֐߲͐ĊǗs܂BPʏSETUP/DATA/HANDSHAKE
 * iK܂B
 */
//@{

//! SETUPvǗɂĂ̏^ċL^邽߂̑S̕ϐ
udd_ctrl_request_t udd_g_ctrlreq;

//! udd_ep_control_statep̴߲Đԋ@\ɂĂޯĒ`
typedef enum {
	UDD_EPCTRL_SETUP = 0,					//!< SETUP߹đ҂
	UDD_EPCTRL_DATA_OUT = 1,				//!< OUTް ߹đ҂
	UDD_EPCTRL_DATA_IN = 2,					//!< INް ߹đ҂
	UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP = 3,	//!< IN ZLP߹đ҂
	UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP = 4,	//!< OUT ZLP߹đ҂
	UDD_EPCTRL_STALL_REQ = 5,				//!< INOUT߹ĂŋꂽSTALL
} udd_ctrl_ep_state_t;

//! ߲ĐǗ̏
static udd_ctrl_ep_state_t udd_ep_control_state;
//! O̖{̊ɏՕް ߹ĒiKɑMꂽް̑
static uint16_t udd_ctrl_prev_payload_nb_trans;
//! udd_g_ctrlreq.payloadɏՕőMꂽް
static uint16_t udd_ctrl_payload_nb_trans;

/**
 * \brief ߲(SETUP/OUT߲0)ŎMްi[ɏՕ
 *
 * {̊ɏՕ߲Ă̑傫ꍇRAMɏՕ邽
 * Ɏgp
 */
static uint8_t udd_ctrl_buffer[USB_DEVICE_EP_CTRL_SIZE];

/**
 * \brief ߲ĊǗؾ
 *
 * USBؾČ܂SETUPv̍Ō(ZLP)ŌĂ΂܂B
 */
static void udd_ctrl_init(void);

//! \brief ߲ĂSETUP߹Ă̊ǗꂽM
static void udd_ctrl_setup_received(void);

//! \brief ߲ĂIN߹Ă̊ǗꂽM
static void udd_ctrl_in_sent(void);

//! \brief ߲ĂOUT߹Ă̊ǗꂽM
static void udd_ctrl_out_received(void);

//! \brief ߲ĂIN߹Ă̊Ǘꂽꎖ
//! ZLPvoRνĂɂĒ~DATAiKôɎgp܂B
//! ͑8͏ɑ΂ĕK{łB
static void udd_ctrl_underflow(void);

//! \brief ߲ĂOUT߹Ă̊Ǘꂽꎖ
//! ZLPvoRνĂɂĒ~DATAiKôɎgp܂B
//! ͑8͏ɑ΂ĕK{łB
static void udd_ctrl_overflow(void);

//! \brief ߲ĂIN/OUT߹Ă̊Ǘꂽ~
static void udd_ctrl_stall_data(void);

//! \brief ߲ĂZLP IN𑗏o
static void udd_ctrl_send_zlp_in(void);

//! \brief ߲ĂZLP OUT𑗏o
static void udd_ctrl_send_zlp_out(void);

//! \brief SETUPvɊ֘AĂі߂Ăт܂B
static void udd_ctrl_endofrequest(void);

/**
 * \brief ߲Ăłُ̈Ǘ邽߂̊荞ݕ⏕ٰ
 *
 * \return ߲ĂɂĂُ̈킪ꍇ\c 1AȂ\c 0
 */
static bool udd_ctrl_interrupt_error(void);

/**
 * \brief ߲ĂSETUP]Ǘ邽߂̊荞ݕ⏕ٰ
 *
 * \return ߲ĂɂSETUP]\c 1AȂ\c 0
 */
static bool udd_ctrl_interrupt_tc_setup(void);

//@}


/**
 * \name (ٸ)/荞/(ɽ)߲Ă̊Ǘ
 *
 * UDDʹ߲Ăް]Ǘ܂B:
 * - USBuDMAŴ߲Ăłް]Jn
 * - vꂽꍇZLP߹Ă𑗏o
 * - ]I}邽߂ɓo^ꂽĂі߂Ăяo
 * ]̒~ƒ~̋@\x܂B
 */
//@{
#if (0!=USB_DEVICE_MAX_EP)

//! ߲Ăœo^ꂽƂɂĂ̍\̒`
typedef struct {
	//!< Ƃ̴߲͂Ăœo^܂B
	uint8_t busy:1;
	//!< Z߹ĂIN߲Ăł̍Ƃɑ΂ėv܂B
	uint8_t b_shortpacket:1;
	//!< ɏՕ͌OUT߲ĂŎgp܂B
	uint8_t b_use_out_cache_buffer:1;
	//!< ƒɑ܂͖߂ɓRAMɒuɏՕ
	uint8_t *buf;
	//!< ܂͖߂̊ɏՕ̑傫
	iram_size_t buf_size;
	//!< ߲Ăœ]ް̑
	iram_size_t nb_trans;
	union {
		//!< ]̍ŌŌĂԌĂі߂
		udd_callback_trans_t call_trans;
		//!< ߲Ē~ꂽɌĂԌĂі߂
		udd_callback_halt_cleared_t call_nohalt;
	};
} udd_ep_job_t;

//! /荞/߲ĂōƂo^邽߂̔z
static udd_ep_job_t udd_ep_job[USB_DEVICE_MAX_EP * 2];

/**
 * \brief /荞ݴ߲ĂŎMްi[ɏՕ
 *
 * gpҊɏՕ߲Ă̑傫ꍇłRAMɏՕ邽
 * Ɏgp
 *
 * \warning ߲Ă̼͂тɂĕی삳ꂸAgp҂͏ɴ߲Ă
 * 傫ɑΉɏՕgpȂ΂Ȃ܂B
 */
#ifdef USB_DEVICE_LOW_SPEED
static uint8_t udd_ep_out_cache_buffer[USB_DEVICE_MAX_EP][8];
#else
static uint8_t udd_ep_out_cache_buffer[USB_DEVICE_MAX_EP][64];
#endif


/**
 * \brief ߲Ĕԍ
 *
 * \param	ep	߲Ĕԍ
 */
bool udd_ep_is_valid(udd_ep_id_t ep);

/**
 * \brief /荞/߲Ăł̓]Ǘ
 *
 * \param	ep	Ǘ߲Ĕԍ
 */
static void udd_ep_trans_complet(udd_ep_id_t ep);

/**
 * \brief ߲Ă̑傫Ԃ܂B
 *
 * \return ݑI΂Ă߲Ă̑傫
 */
static uint16_t udd_ep_get_size(UDD_EP_t * ep_ctrl);

/**
 * \brief ߲ĔԍɑΉ߲čƂ̈ʒuwqԂ܂B
 *
 * \param	ep	(USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 */
static udd_ep_job_t *udd_ep_get_job(udd_ep_id_t ep);

#endif // (0!=USB_DEVICE_MAX_EP)
//@}


void udd_enable(void)
{
	uint8_t i;
	irqflags_t flags;

	// غ݉S
#if AVR8_PART_IS_DEFINED(ATxmega128A1U)
	// ATxmega128A1UJ޲͕sxAVgpĂB
	Assert(!(MCU_REVID < 0x0A));
#endif

#ifdef CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC
# if CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC == OSC_ID_USBSOF
	// USBڰъJnoRRCUZ͒ᑬŗpsłB̂USB̪
	// ᑬŊJn鎞ɍZ֎~܂B
	DFLLRC32M.CTRL = 0;
# endif
#endif

#ifdef USB_DEVICE_LOW_SPEED
	// USBʰ޳͒ᑬ6MHz̕Kv܂B
	sysclk_enable_usb(6);
	udd_set_low_speed();
#else
	// USBʰ޳͑S48MHz̕Kv܂B
	sysclk_enable_usb(48);
	udd_set_full_speed();
#endif

// XMEGA_A1U͒ʐM(ᑬ)ʂRCZx܂B
#if (!defined USB_DEVICE_LOW_SPEED) || (!XMEGA_A1U)
# ifdef CONFIG_OSC_AUTOCAL
#   if CONFIG_OSC_AUTOCAL_REF_OSC == OSC_ID_USBSOF
	// SOFZ邱Ƃł܂B
	DFLLRC32M.CTRL = DFLL_ENABLE_bm;
#   endif
# endif
#endif

	flags = cpu_irq_save();

	// ߲ĕ\ؾ
	for (i = 0; i < ((USB_DEVICE_MAX_EP + 1) * 2); i++) {
		udd_sram.ep_ctrl[i].CTRL = 0;
	}
#if (0!=USB_DEVICE_MAX_EP)
	// ϐؾ
	for (i = 0; i < (USB_DEVICE_MAX_EP * 2); i++) {
		udd_ep_job[i].busy = false;
	}
#endif

	//** USBʰ޳
	usb_pad_init();
	udd_set_nb_max_ep(USB_DEVICE_MAX_EP);
	udd_enable_interface();
	udd_enable_store_frame_number();
	udd_set_ep_table_addr(udd_sram.ep_ctrl);
	// TCFIFOǗ
	udd_enable_fifo();
	udd_reset_fifo();
	// USBu荞݋
	udd_enable_interrupt(UDD_USB_INT_LEVEL);

#ifndef UDD_NO_SLEEP_MGR
	// USBꎞ~ɑ΂ĔFꂽx~
	udd_b_idle = false;
	sleepmgr_lock_mode(USBC_SLEEP_MODE_USB_SUSPEND);
#endif

	cpu_irq_restore(flags);
}


void udd_disable(void)
{
	irqflags_t flags;
	flags = cpu_irq_save();
	udd_detach_device();
	// ̪֎~
	USB_INTCTRLA = 0;
	USB_INTCTRLB = 0;
	sysclk_disable_usb();
	udd_sleep_mode(false);
#ifndef UDD_NO_SLEEP_MGR
	sleepmgr_unlock_mode(USBC_SLEEP_MODE_USB_SUSPEND);
#endif
	cpu_irq_restore(flags);
}

bool udd_include_vbus_monitoring(void)
{
	return false;	// VBUSĎȂ
}

void udd_attach(void)
{
	irqflags_t flags;
	flags = cpu_irq_save();

	// nUSB޽Ԃ͖mA]āAǂUSBۂȂ߂ɏԂIDLE
	// 􂳂܂B
	udd_sleep_mode(true);

	udd_ack_suspend_event();
	udd_ack_resume_event();
	udd_attach_device();
	// USB荞݋
	udd_enable_tc_interrupt();
	udd_enable_busevt_interrupt();
	udd_enable_setup_interrupt();
	udd_enable_start_of_frame_interrupt();

	cpu_irq_restore(flags);
}

void udd_detach(void)
{
	// ޽瑕uO
	udd_detach_device();
}

bool udd_is_high_speed(void)
{
	return false;
}

void udd_set_address(uint8_t address)
{
	udd_set_device_address(address);
}

uint8_t udd_getaddress(void)
{
	return udd_get_device_address();
}

uint16_t udd_get_frame_number(void)
{
	return udd_sram.frame_number;
}

uint16_t udd_get_micro_frame_number(void)
{
	return 0;
}

void udd_send_remotewakeup(void)
{
#ifndef UDD_NO_SLEEP_MGR
	if (!udd_b_idle)
#endif
	{
		udd_sleep_mode(true);	// IDLEڍs
		udd_send_remote_wake_up();
	}
}

void udd_set_setup_payload( uint8_t *payload, uint16_t payload_size )
{
	udd_g_ctrlreq.payload = payload;
	udd_g_ctrlreq.payload_size = payload_size;
}

#if (0!=USB_DEVICE_MAX_EP)
bool udd_ep_alloc(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize)
{
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	if (udd_endpoint_is_enable(ep_ctrl)) {
		return false;	// Ɋ蓖čς
	}
	udd_ep_init(ep, bmAttributes, MaxEndpointSize);

	// 1023޲ ߲Ăŕ߹ēgpȂB
	if (udd_endpoint_get_type(ep_ctrl)==USB_EP_TYPE_ISOCHRONOUS_gc
			&& (udd_endpoint_get_size_field(ep_ctrl)
			==USB_EP_BUFSIZE_1023_gc)) {
		return true;
	}

	udd_endpoint_set_multipacket(ep_ctrl);
	return true;
}

void udd_ep_free(udd_ep_id_t ep)
{
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	udd_ep_abort(ep);
	ep_ctrl = udd_ep_get_ctrl(ep);
	udd_endpoint_disable(ep_ctrl);
}

bool udd_ep_is_halted(udd_ep_id_t ep)
{
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	return (udd_endpoint_is_stall(ep_ctrl));
}

bool udd_ep_set_halt(udd_ep_id_t ep)
{
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	udd_endpoint_enable_stall(ep_ctrl);
	udd_endpoint_clear_dtgl(ep_ctrl);

	udd_ep_abort(ep);
	return true;
}

bool udd_ep_clear_halt(udd_ep_id_t ep)
{
	udd_ep_job_t *ptr_job;
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	if (!udd_endpoint_is_stall(ep_ctrl)) {
		return true;	// is̒~Ȃ
	}
	udd_endpoint_disable_stall(ep_ctrl);

	// Ƃ~œo^ȂAĂі߂s
	ptr_job = udd_ep_get_job(ep);
	if (ptr_job->busy == true) {
		ptr_job->busy = false;
		ptr_job->call_nohalt();
	}
	return true;
}

bool udd_ep_run(udd_ep_id_t ep, bool b_shortpacket, uint8_t * buf,
		iram_size_t buf_size, udd_callback_trans_t callback)
{
	udd_ep_job_t *ptr_job;
	irqflags_t flags;
	UDD_EP_t *ep_ctrl;

	Assert(udd_ep_is_valid(ep));

	// ̴߲Ăɑ΂鐧ƍƂ擾
	ptr_job = udd_ep_get_job(ep);
	ep_ctrl = udd_ep_get_ctrl(ep);

	if (!udd_endpoint_is_enable(ep_ctrl)) {
		return false;	// ߲Ċ蓖ĂȂ
	}
	if (udd_endpoint_get_type(ep_ctrl)!=USB_EP_TYPE_ISOCHRONOUS_gc
		&& udd_endpoint_is_stall(ep_ctrl)) {
		return false;	// ߲Ē~
	}
	flags = cpu_irq_save();
	if (ptr_job->busy == true) {
		cpu_irq_restore(flags);
		return false;	// Ƃɐis
	}
	ptr_job->busy = true;
	cpu_irq_restore(flags);


	// ƏXV
	ptr_job->buf = buf;
	ptr_job->buf_size = buf_size;
	ptr_job->nb_trans = 0;
	ptr_job->call_trans = callback;
	// ZLP(buf_size==0)𑗂邽߂ɒZ߹Ă̋Kv
	ptr_job->b_shortpacket = b_shortpacket || (buf_size==0);
	ptr_job->b_use_out_cache_buffer = false;

	// ]U邽߂ɒl
	if (USB_EP_DIR_IN == (ep & USB_EP_DIR_IN)) {
		udd_endpoint_in_reset_nb_sent(ep_ctrl);
	}
	else
	{
		if ((USB_EP_TYPE_ISOCHRONOUS_gc == udd_endpoint_get_type(ep_ctrl))
		&& (0 != (buf_size % udd_ep_get_size(ep_ctrl)))) {
			// gp҂͊ɏՕ̑傫߲Ă̑傫̏]gpȂ΂Ȃ܂B
			ptr_job->busy = false;
			return false;
		}
		udd_endpoint_out_reset_nb_received(ep_ctrl);
		udd_endpoint_out_set_nbbyte(ep_ctrl, 0);
	}
	// ̓]v
	udd_ep_trans_complet(ep);
	return true;
}

void udd_ep_abort(udd_ep_id_t ep)
{
	UDD_EP_t *ep_ctrl;
	udd_ep_job_t *ptr_job;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	ptr_job = udd_ep_get_job(ep);

	// ]~
	udd_endpoint_set_NACK0(ep_ctrl);
	if (ptr_job->busy == false) {
		return;	// is̍ƂȂ
	}
	ptr_job->busy = false;
	if (NULL != ptr_job->call_trans) {
		ptr_job->call_trans(UDD_EP_TRANSFER_ABORT,
				(ep & USB_EP_DIR_IN) ?
				udd_endpoint_in_nb_sent(ep_ctrl)
				: udd_endpoint_out_nb_receiv(ep_ctrl));
	}
}

bool udd_ep_wait_stall_clear(udd_ep_id_t ep,
		udd_callback_halt_cleared_t callback)
{
	udd_ep_job_t *ptr_job;
	UDD_EP_t *ep_ctrl;
	Assert(udd_ep_is_valid(ep));

	ep_ctrl = udd_ep_get_ctrl(ep);
	ptr_job = udd_ep_get_job(ep);

	if (udd_endpoint_is_stall(ep_ctrl)) {
		// ~߲ĉ҂
		if (ptr_job->busy == true) {
			return false;	// Ƃɐis
		}
		ptr_job->busy = true;
		ptr_job->call_nohalt = callback;
	} else {
		// ߲Ă~łȂAڌĂі߂Ăяo
		callback();
	}
	return true;
}
#endif // (0!=USB_DEVICE_MAX_EP)

//--------------------------------------------------------
//--- ǗꂽS̎ۂ̂߂ٰ̓

/**
 * \internal
 * \brief USB޽ۊ荞݂ɂČĂ΂֐
 *
 * USB޽ۊ荞݂͈ȉ܂݂܂B:
 * - SOFAؾāAꎞ~AĊJANオUSB
 * - AAf̴߲Đُ
 */
ISR(USB_BUSEVENT_vect)
{
	if (udd_is_start_of_frame_event()) {
		udd_ack_start_of_frame_event();
		udc_sof_notify();
#ifdef UDC_SOF_EVENT
		UDC_SOF_EVENT();
#endif
		goto udd_interrupt_bus_event_end;
	}

	if (udd_ctrl_interrupt_error()) {
		goto udd_interrupt_bus_event_end;
	}
	if (udd_is_reset_event()) {
		udd_ack_reset_event();
#if (0!=USB_DEVICE_MAX_EP)
		// is̑S߲čƂ𒆎~
		uint8_t i;
		for (i = 1; i < USB_DEVICE_MAX_EP; i++) {
			udd_ep_abort(i);
			udd_ep_abort(i | USB_EP_DIR_IN);
		}
#endif
		udc_reset();

		// USBڽ0ؾ
		udd_set_device_address(0);
		// ߲Ă蓖ĂČ`Ԑݒ
		udd_ep_init(0, USB_EP_TYPE_CONTROL, USB_DEVICE_EP_CTRL_SIZE);
		udd_ep_init(0 | USB_EP_DIR_IN, USB_EP_TYPE_CONTROL,
				USB_DEVICE_EP_CTRL_SIZE);
		udd_control_out_set_buf(&udd_ctrl_buffer);
		// ߲ĐǗؾ
		udd_ctrl_init();
		goto udd_interrupt_bus_event_end;
	}

	if (udd_is_suspend_event()) {
		udd_ack_suspend_event();
		udd_sleep_mode(false);	// ꎞ~(SUSPEND)Ɉڍs
#ifdef UDC_SUSPEND_EVENT
		UDC_SUSPEND_EVENT();
#endif
		goto udd_interrupt_bus_event_end;
	}

	if (udd_is_resume_event()) {
		udd_ack_resume_event();
		udd_sleep_mode(true);	// d͍팸Ɉڍs
#ifdef UDC_RESUME_EVENT
		UDC_RESUME_EVENT();
#endif
		goto udd_interrupt_bus_event_end;
	}

udd_interrupt_bus_event_end:
	return;
}

/**
 * \internal
 * \brief USB]荞݂ɂČĂ΂֐
 *
 * USB]荞݂͑S߲Ăł̴߲ē]ɂĂ̎ۂ܂݂܂B
 */
ISR(USB_TRNCOMPL_vect)
{
#if (0!=USB_DEVICE_MAX_EP)
	uint8_t ep_index;
	uint8_t i_fifo;
	uint16_t ad;
	uint16_t *p_ad;
	int8_t rp;
	UDD_EP_t *ep_ctrl;
	udd_ep_id_t ep;
#endif

	if (!udd_is_tc_event()) {
		// ɓ]Ȃ΁A߲ĂSETUP߹Ă̎M𒲍
		if (udd_ctrl_interrupt_tc_setup()) {
			// Ǘꂽ߲Ăɂĉꂽ荞
			goto udd_interrupt_tc_end;
		}
		Assert(false);
	}
	// SĂ̴߲ĂIN/OUT]ɏՂ𒲍
	udd_ack_tc_event();

#if (0!=USB_DEVICE_MAX_EP)
	//** TC FIFO
	// ߲ ڽvZ
	rp = udd_get_fifo_rp();
	i_fifo = 2 * (1 + ~rp);
	ad = ((uint16_t) udd_sram.ep_ctrl) - i_fifo;
	p_ad = (uint16_t *) ad;
	// epvZ
	ep_index = (((uint16_t) * p_ad - ((uint16_t) udd_sram.ep_ctrl)) >> 3);
	ep = (ep_index / 2) + ((ep_index & 1) ? USB_EP_DIR_IN : 0);
	Assert(USB_DEVICE_MAX_EP >= (ep & USB_EP_ADDR_MASK));

	// ߲ĂTC荞݉
	ep_ctrl = udd_ep_get_ctrl(ep);
	if (!udd_endpoint_transfer_complete(ep_ctrl)) {
		return;	// ُATC͕߹ē]ɂĐ܂B
	}
	udd_endpoint_ack_transfer_complete(ep_ctrl);

	// ߲Ă̏Ԓ
	if (ep == 0) {
		udd_ctrl_out_received();
		goto udd_interrupt_tc_end;	// Ǘꂽ߲Ăɂĉ銄荞
	}
	if (ep == (0 | USB_EP_DIR_IN)) {
		udd_ctrl_in_sent();
		goto udd_interrupt_tc_end; // Ǘꂽ߲Ăɂĉ銄荞
	}
	Assert(udd_ep_is_valid(ep));
	// /荞/߲Ăł̓]IǗ
	udd_ep_trans_complet(ep);

#else

	udd_get_fifo_rp();
	if (udd_endpoint_transfer_complete(udd_ep_get_ctrl(0))) {
		udd_endpoint_ack_transfer_complete(udd_ep_get_ctrl(0));
		udd_ctrl_out_received();
	}else{
		udd_endpoint_ack_transfer_complete(udd_ep_get_ctrl(0 | USB_EP_DIR_IN));
		udd_ctrl_in_sent();
	}
#endif

udd_interrupt_tc_end:
	return;
}

//--------------------------------------------------------
//--- ߲Ă邽߂ٰ̓

static void udd_ep_init(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize)
{
	USB_EP_TYPE_t type;
	USB_EP_BUFSIZE_t size;
	UDD_EP_t *ep_ctrl;

#if (0!=USB_DEVICE_MAX_EP)
	// USBʰ޳`ɕϊ
	switch (bmAttributes & USB_EP_TYPE_MASK) {
	case USB_EP_TYPE_CONTROL:
		type = USB_EP_TYPE_CONTROL_gc;
		break;
	case USB_EP_TYPE_ISOCHRONOUS:
		type = USB_EP_TYPE_ISOCHRONOUS_gc;
		break;
	case USB_EP_TYPE_BULK:
	case USB_EP_TYPE_INTERRUPT:	// 荞݂͑(ٸ)Ƃē܂B
		type = USB_EP_TYPE_BULK_gc;
		break;
	default:
		Assert(false);	// sl
		break;
	}
#else
	type = USB_EP_TYPE_CONTROL_gc;
#endif

	// USB߲Ă̑傫ʰ޳`ɕϊ
	switch (MaxEndpointSize) {
	default:
		Assert(false);	// sl
	case 8:
		size = USB_EP_BUFSIZE_8_gc;
		break;
	case 16:
		size = USB_EP_BUFSIZE_16_gc;
		break;
	case 32:
		size = USB_EP_BUFSIZE_32_gc;
		break;
	case 64:
		size = USB_EP_BUFSIZE_64_gc;
		break;
#if (0!=USB_DEVICE_MAX_EP)
	case 128:
		size = USB_EP_BUFSIZE_128_gc;
		break;
	case 256:
		size = USB_EP_BUFSIZE_256_gc;
		break;
	case 512:
		size = USB_EP_BUFSIZE_512_gc;
		break;
	case 1023:
		size =USB_EP_BUFSIZE_1023_gc;
		break;
#endif
	}

	// ߲ċ
	ep_ctrl = udd_ep_get_ctrl(ep);
	udd_endpoint_disable(ep_ctrl);
	udd_endpoint_clear_status(ep_ctrl);
	udd_endpoint_set_control(ep_ctrl, (uint8_t) type | (uint8_t) size);
}

static UDD_EP_t *udd_ep_get_ctrl(udd_ep_id_t ep)
{
	return &udd_sram.ep_ctrl[(2 * (ep & USB_EP_ADDR_MASK) +
			((ep & USB_EP_DIR_IN) ? 1 : 0))];
}


//--------------------------------------------------------
//--- ߲ĂǗ邽߂ٰ̓

static void udd_ctrl_init(void)
{
	udd_disable_overflow_interrupt();
	udd_disable_underflow_interrupt();

	// ߲Ă̏׸ނ
	// ATxmega128A1Kɑ΂ĕK{
	udd_control_in_set_NACK0();
	udd_control_in_set_bytecnt(0);
	udd_control_in_ack_tc();
	udd_control_ack_in_underflow();
	udd_control_out_ack_tc();
	udd_control_ack_out_overflow();

	udd_g_ctrlreq.callback = NULL;
	udd_g_ctrlreq.over_under_run = NULL;
	udd_g_ctrlreq.payload_size = 0;
	udd_ep_control_state = UDD_EPCTRL_SETUP;
}

static void udd_ctrl_setup_received(void)
{
	if (UDD_EPCTRL_SETUP != udd_ep_control_state) {
		if ((UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP == udd_ep_control_state)
				|| (UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP == udd_ep_control_state)) {
			// SETUP߹ĂZLPfꍇZLPۂSETUP߹Ďۂɂ
			// B꓾邱Ƃ󂯓
			udd_ctrl_endofrequest();
		}
		// ߲ĊǗď
		udd_ctrl_init();
	}
	// SETUPv\̂𖞂B
	if (8 != udd_control_out_get_bytecnt())
		return;	// SETUP߹ĂɑΉȂްԍ
	memcpy((uint8_t *) & udd_g_ctrlreq.req, udd_ctrl_buffer, 8);

	// SETUPł̋Kُo邽߁A߲ĂłNAK荞݂
	udd_enable_overflow_interrupt();
	udd_enable_underflow_interrupt();

	// SETUPv𕜍
	if (udc_process_setup() == false) {
		// SETUPvmȂ璆f
		udd_ctrl_stall_data();
		return;
	}

	if (Udd_setup_is_in()) {
		udd_ctrl_prev_payload_nb_trans = 0;
		udd_ctrl_payload_nb_trans = 0;
		udd_ep_control_state = UDD_EPCTRL_DATA_IN;
		udd_ctrl_in_sent();	// ŏް]o
	} else {
		if (0 == udd_g_ctrlreq.req.wLength) {
			//	vްiKȂASETUPvACK̂߂IN ZLPo
			udd_ctrl_send_zlp_in();
			return;
		}
		// vꂽOUTްiK
		udd_ctrl_prev_payload_nb_trans = 0;
		udd_ctrl_payload_nb_trans = 0;
		udd_ep_control_state = UDD_EPCTRL_DATA_OUT;
		// ŏ߹ĂM邽߂߹ĉ
		udd_control_out_clear_NACK0();
	}
}

static void udd_ctrl_in_sent(void)
{
	static bool b_shortpacket = false;
	uint16_t nb_remain;

	if (UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP == udd_ep_control_state) {
		// INZLPfǍɗLSETUPv̍Ō
		udd_ctrl_endofrequest();
		// ߲ĊǗď
		udd_ctrl_init();
		return;
	}
	Assert(udd_ep_control_state == UDD_EPCTRL_DATA_IN);

	nb_remain = udd_g_ctrlreq.payload_size - udd_ctrl_payload_nb_trans;
	if (0 == nb_remain) {
		// O̖{̊ɏՕɂđްXV
		udd_ctrl_prev_payload_nb_trans += udd_ctrl_payload_nb_trans;
		if ((udd_g_ctrlreq.req.wLength == udd_ctrl_prev_payload_nb_trans)
				|| b_shortpacket) {
			// vꂽSް]ꂽA܂͒Z߹ĂǍް
			// iK̍ŌB޼iKpOUT ZLP𐶐B
			udd_ctrl_send_zlp_out();
			return;
		}
		// ްiKŝ߁AVɏՕKv
		if ((!udd_g_ctrlreq.over_under_run)
				|| (!udd_g_ctrlreq.over_under_run())) {
			// INłZLPo
			// nb_remain == 0IN ZLPo܂B
		} else {
			// V{̊ɏՕ^܂B
			udd_ctrl_payload_nb_trans = 0;
			nb_remain = udd_g_ctrlreq.payload_size;
		}
	}
	// ޲đo]p
	if (nb_remain >= USB_DEVICE_EP_CTRL_SIZE) {
		nb_remain = USB_DEVICE_EP_CTRL_SIZE;
		b_shortpacket = false;
	} else {
		b_shortpacket = true;
	}
	udd_control_in_set_bytecnt(nb_remain);

	// USBʰ޳Ŗ{̊ɏՕ𒼐ړIɐڑ
	udd_control_in_set_buf(udd_g_ctrlreq.payload + udd_ctrl_payload_nb_trans);
	udd_ctrl_payload_nb_trans += nb_remain;

	// LŐ߲ĊɏՕŗp\ް𑗏o
	udd_control_in_clear_NACK0();
}

static void udd_ctrl_out_received(void)
{
	uint16_t nb_data;

	if (UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP == udd_ep_control_state) {
		// SETUPv̍ŌL
		udd_ctrl_endofrequest();
		// ߲ĊǗď
		udd_ctrl_init();
		return;
	}
	Assert(udd_ep_control_state == UDD_EPCTRL_DATA_OUT);

	// OUTiKɎMްǂݍ
	nb_data = udd_control_out_get_bytecnt();

	if (udd_g_ctrlreq.payload_size < (udd_ctrl_payload_nb_trans + nb_data)) {
		// {̊ɏՕAcް
		nb_data = udd_g_ctrlreq.payload_size - udd_ctrl_payload_nb_trans;
	}

	memcpy((uint8_t *) (udd_g_ctrlreq.payload + udd_ctrl_payload_nb_trans),
			udd_ctrl_buffer, nb_data);
	udd_ctrl_payload_nb_trans += nb_data;

	if ((USB_DEVICE_EP_CTRL_SIZE != nb_data) || (udd_g_ctrlreq.req.wLength
			<= (udd_ctrl_prev_payload_nb_trans
			+ udd_ctrl_payload_nb_trans))) {
		// Z߹Ă܂͑Sް]ꂽߎM̍Ō

		// ZLPoOްMf𐶐ꍇɒԌĂі߂Ăяo
		udd_g_ctrlreq.payload_size = udd_ctrl_payload_nb_trans;
		if (NULL != udd_g_ctrlreq.over_under_run) {
			if (!udd_g_ctrlreq.over_under_run()) {
				// fZLP
				udd_ctrl_stall_data();
				return;
			}
		}
		// SETUPvACK邽߂IN ZLP𑗏o
		udd_ctrl_send_zlp_in();
		return;
	}

	if (udd_g_ctrlreq.payload_size == udd_ctrl_payload_nb_trans) {
		// ް݂ŁAV{̊ɏՕv
		if (!udd_g_ctrlreq.over_under_run) {
			// V{̊ɏՕv̂ɗp\ȓі߂Ȃ
			udd_ctrl_stall_data();
			return;
		}
		if (!udd_g_ctrlreq.over_under_run()) {
			// V{̊ɏՕzȂ
			udd_ctrl_stall_data();
			return;
		}
		// V{̊ɏՕp\BMްXV
		udd_ctrl_prev_payload_nb_trans += udd_ctrl_payload_nb_trans;
		// {̊ɏՕł̎Mď
		udd_ctrl_payload_nb_trans = 0;
	}
	// MF̂߂OUT߲Ă̋ɏՕ
	udd_control_out_clear_NACK0();
}

static void udd_ctrl_underflow(void)
{
	if (udd_is_tc_event() || udd_ctrl_interrupt_tc_setup()) {
		return;	// ]ꂽꍇɖ鉺
	}
	if (UDD_EPCTRL_DATA_OUT == udd_ep_control_state) {
		// νĂOUTPʏ~vǍOUTްiK҂IN ZLP޼
		// ҂߂ɒ~
		udd_ctrl_send_zlp_in();
	} else if (UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP == udd_ep_control_state) {
		// OUT޼uɂđ҂܂AνĂ͒ǉINް]݁Ǎɒ
		// INް𒆒fďԒiKɏ]܂B
		udd_control_in_enable_stall();
		udd_control_out_enable_stall();
	}
}

static void udd_ctrl_overflow(void)
{
	if (udd_is_tc_event() || udd_ctrl_interrupt_tc_setup()) {
		return;	// ]ꂽꍇɖ
	}
	if (UDD_EPCTRL_DATA_IN == udd_ep_control_state) {
		// νĂINPʏ~vǍINްiK҂OUT ZLP޼
		// ҂߂ɒ~܂B
		udd_ctrl_send_zlp_out();
	} else if (UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP == udd_ep_control_state) {
		// IN޼͑uɂđ҂܂AνĂ͒ǉOUTް]݁Ǎ
		// ǉOUTް𒆒fďԒiKɏ]܂B
		udd_control_in_enable_stall();
		udd_control_out_enable_stall();
	}
}

static void udd_ctrl_stall_data(void)
{
	// INOUT߲̐ĂőS߹Ă𒆒f
	udd_ep_control_state = UDD_EPCTRL_STALL_REQ;
	udd_control_in_enable_stall();
	udd_control_out_enable_stall();
}

static void udd_ctrl_send_zlp_in(void)
{
	udd_ep_control_state = UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP;
	// LŐ߲ĂŋIN߹đo
	udd_control_in_set_bytecnt(0);
	udd_control_in_clear_NACK0();
}

static void udd_ctrl_send_zlp_out(void)
{
	udd_ep_control_state = UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP;
	// ߲ĂOUT߹Ă̗LM
	udd_control_out_clear_NACK0();
}

static void udd_ctrl_endofrequest(void)
{
	// Ăі߂o^Ă΁AĂяo
	if (udd_g_ctrlreq.callback) {
		udd_g_ctrlreq.callback();
	}
}

static bool udd_ctrl_interrupt_error(void)
{
	// ߲͐Ăɑ΂ĂǗ
	if (udd_is_underflow_event()) {
		udd_ack_underflow_event();
		if (udd_control_in_underflow()) {
			udd_ctrl_underflow();
		}
		return true;
	}
	// ߲͐Ăɑ΂ĂǗ
	if (udd_is_overflow_event()) {
		udd_ack_overflow_event();
		if (udd_control_out_overflow()) {
			udd_ctrl_overflow();
		}
		return true;
	}
	return false;
}

static bool udd_ctrl_interrupt_tc_setup(void)
{
	if (!udd_is_setup_event()) {
		return false;
	}
	udd_ack_setup_event();

	// ǑO̒fۂ
	udd_control_out_ack_stall();
	udd_control_in_ack_stall();
	udd_ack_stall_event();

	Assert(udd_control_setup());	// SETUP߲͐ĂŎMȂ΂Ȃ܂B

	// SETUP߹ĉƗv
	udd_control_ack_setup();
	udd_ctrl_setup_received();
	return true;
}


//--------------------------------------------------------
//--- (ٸ)/荞/߲ĊǗpٰ

#if (0!=USB_DEVICE_MAX_EP)

static uint16_t udd_ep_get_size(UDD_EP_t * ep_ctrl)
{
	// ʰ޳`USB߲Ă̑傫ɕϊ
	switch (udd_endpoint_get_size_field(ep_ctrl)) {
	default:
	case USB_EP_BUFSIZE_8_gc:
		return 8;
	case USB_EP_BUFSIZE_16_gc:
		return 16;
	case USB_EP_BUFSIZE_32_gc:
		return 32;
	case USB_EP_BUFSIZE_64_gc:
		return 64;
	case USB_EP_BUFSIZE_128_gc:
		return 128;
	case USB_EP_BUFSIZE_256_gc:
		return 256;
	case USB_EP_BUFSIZE_512_gc:
		return 512;
	case USB_EP_BUFSIZE_1023_gc:
		return 1023;
	}
}

static udd_ep_job_t *udd_ep_get_job(udd_ep_id_t ep)
{
	return &udd_ep_job[(2 * (ep & USB_EP_ADDR_MASK) +
		((ep & USB_EP_DIR_IN) ? 1 : 0)) - 2];
}

bool udd_ep_is_valid(udd_ep_id_t ep)
{
	ep &= USB_EP_ADDR_MASK;
	if (ep == 0) {
		return false;
	}
	return (USB_DEVICE_MAX_EP >= ep);
}

static void udd_ep_trans_complet(udd_ep_id_t ep)
{
	UDD_EP_t *ep_ctrl;
	udd_ep_job_t *ptr_job;
	uint16_t ep_size, nb_trans;
	iram_size_t next_trans;

	ptr_job = udd_ep_get_job(ep);
	ep_ctrl = udd_ep_get_ctrl(ep);
	ep_size = udd_ep_get_size(ep_ctrl);

	if (USB_EP_DIR_IN == (ep & USB_EP_DIR_IN)) {
		// INł̓]
		nb_trans = udd_endpoint_in_nb_sent(ep_ctrl);

		// ]ްXV
		ptr_job->nb_trans += nb_trans;

		// ްoKv
		if (ptr_job->nb_trans != ptr_job->buf_size) {
			next_trans = ptr_job->buf_size - ptr_job->nb_trans;
			if (UDD_ENDPOINT_MAX_TRANS < next_trans) {
				// USBʰ޳UDD_ENDPOINT_MAX_TRANS޲Ă̍ő]ʂx
				next_trans = UDD_ENDPOINT_MAX_TRANS -
					(UDD_ENDPOINT_MAX_TRANS % ep_size);
			}
			// vꂽꍇZLPKvAŏI߹Ă͒Z߹Ăł͂܂B
			ptr_job->b_shortpacket = ptr_job->b_shortpacket
				&& (0==(next_trans % ep_size));
			udd_endpoint_in_reset_nb_sent(ep_ctrl);
			udd_endpoint_in_set_bytecnt(ep_ctrl, next_trans);
			// USBʰ޳DMAŎgpҊɏՕ𒼐ړIɐڑ
			udd_endpoint_set_buf(ep_ctrl, &ptr_job->buf[ptr_job->nb_trans]);
			udd_endpoint_clear_NACK0(ep_ctrl);
			return;
		}

		// Sް]ZLPoKv
		if (ptr_job->b_shortpacket) {
			ptr_job->b_shortpacket = false;
			udd_endpoint_in_reset_nb_sent(ep_ctrl);
			udd_endpoint_in_set_bytecnt(ep_ctrl, 0);
			udd_endpoint_clear_NACK0(ep_ctrl);
			return;
		}
	}
	else
	{
		// OUTł̓]
		nb_trans = udd_endpoint_out_nb_receiv(ep_ctrl);

		// ɏՕgpҊɏՕ֎MްʂKv܂B
		if (ptr_job->b_use_out_cache_buffer) {
			memcpy(&ptr_job->buf[ptr_job->nb_trans]
				, udd_ep_out_cache_buffer[ep - 1]
				, ptr_job->buf_size % ep_size);
		}

		// ]ްXV
		ptr_job->nb_trans += nb_trans;
		if (ptr_job->nb_trans > ptr_job->buf_size) {
			ptr_job->nb_trans = ptr_job->buf_size;
		}

		// vꂽȎSްMĎgpҊɏՕtłȂȂAް
		// ̎MKv
		if ((nb_trans == udd_endpoint_out_get_nbbyte_requested(ep_ctrl))
			&& (ptr_job->nb_trans != ptr_job->buf_size)) {
			next_trans = ptr_job->buf_size - ptr_job->nb_trans;
			if (UDD_ENDPOINT_MAX_TRANS < next_trans) {
				// USBʰ޳UDD_ENDPOINT_MAX_TRANS޲ނ̍ő]ʂx
				next_trans = UDD_ENDPOINT_MAX_TRANS
					- (UDD_ENDPOINT_MAX_TRANS % ep_size);
			} else {
				next_trans -= next_trans % ep_size;
			}

			udd_endpoint_out_reset_nb_received(ep_ctrl);
			if (next_trans < ep_size) {
				// ʂ܂͊荞݂̑傫̴߲Ăɑ΂ķɏՕgp
				ptr_job->b_use_out_cache_buffer = true;
				udd_endpoint_set_buf( ep_ctrl,
					udd_ep_out_cache_buffer[((ep & USB_EP_ADDR_MASK) - 1)]);
				udd_endpoint_out_set_nbbyte(ep_ctrl, ep_size);
			} else {
				// USBʰ޳DMAŎgpҊɏՕ𒼐ړIɐڑ
				udd_endpoint_set_buf(ep_ctrl, &ptr_job->buf[ptr_job->nb_trans]);
				udd_endpoint_out_set_nbbyte(ep_ctrl, next_trans);
			}
			// ]Jn
			udd_endpoint_clear_NACK0(ep_ctrl);
			return;
		}
	}

	// ƊǍɌĂі߂Ăяo
	if (ptr_job->busy) {
		ptr_job->busy = false;
		if (NULL != ptr_job->call_trans) {
			ptr_job->call_trans(UDD_EP_TRANSFER_OK,
				ptr_job->nb_trans);
		}
	}
	return;
}
#endif // (0!=USB_DEVICE_MAX_EP)
//@}
